UNIT NUMCONV;
INTERFACE
USES MODE3,WINU;
TYPE PCHARFILTER=^TCHARFILTER;
     TCHARFILTER=OBJECT
      CH:ARRAY[0..255] OF BYTE;
      PROCEDURE FILL(S,L,C:BYTE);
      CONSTRUCTOR LOAD(S:STRING);
      DESTRUCTOR SAVE(S:STRING);
     END;
TYPE PSTR=^TSTR;
     TSTR=OBJECT
      PRIVATE
      CHS:PCHAR;
      MAXLEN,FILL:LONGINT;
      PUBLIC
      PROCEDURE SETCHAR(X,Y:LONGINT;C:SYSTEM.CHAR);
      FUNCTION MEMFILL:LONGINT;
      FUNCTION MEMFREE:LONGINT;
      FUNCTION LINEATPOS(P:LONGINT):LONGINT;
      FUNCTION GETLINELENGTH(L:LONGINT):LONGINT;
      FUNCTION GETLINECOUNT:LONGINT;
      FUNCTION GETLINE(N:WORD):STRING;
      FUNCTION GETLINESTART(L:LONGINT):LONGINT;
      FUNCTION GETLINEAT(VAR P:LONGINT):STRING;
      FUNCTION GETLINEEND(L:LONGINT):LONGINT;
      PROCEDURE INSERT(P:LONGINT;S:STRING);
      PROCEDURE DELETE(P,C:LONGINT);
      CONSTRUCTOR INIT(ML:LONGINT);
      DESTRUCTOR DONE;
      PROCEDURE LOAD(S:STRING);
      PROCEDURE SAVE(S:STRING);
      PROCEDURE ADD(S:STRING);
      PROCEDURE CLEAR;
     END;
TYPE PPTLIST_I=^TPTLIST_I;
     TPTLIST_I=RECORD
      PT:POINTER;
      NEXT,LAST:PPTLIST_I;
     END;
TYPE PPTLIST=^TPTLIST;
     TPTLIST=OBJECT
      PRIVATE
      FIRST:PPTLIST_I;
      COUNT:LONGINT;
      PUBLIC
      CONSTRUCTOR INIT;
      DESTRUCTOR DONE;
      PROCEDURE CLEAR;
      PROCEDURE INSERT(IP:LONGINT;P:POINTER);
      PROCEDURE DELETE(IP:LONGINT);
      FUNCTION GETCOUNT:LONGINT;
      FUNCTION GET(IP:LONGINT):POINTER;
      PROCEDURE ADD(P:POINTER);
      PROCEDURE ADDS(P:POINTER);
     END;
CONST CHA:ARRAY[0..255] OF SYSTEM.CHAR=(
      '0','1','2','3','4','5','6','7','8','9','A','B','C','D','E','F',
      'G','H','I','J','K','L','M','N','O','P','Q','R','S','T','U','V',
      'W','X','Y','Z',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
      ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
      ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
      ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
      ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
      ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
      ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
      ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
      ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
      ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
      ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
      ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
      ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',
      ' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ',' ');
CONST UCH:ARRAY[0..255] OF BYTE=(
      255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
      255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
      255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
      255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
      255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
      255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
      255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
      255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
      255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
      255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
      255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
      255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
      255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
      255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
      255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,
      255,255,255,255,255,255,255,255,255,255,255,255,255,255,255,255);
FUNCTION NUMSTR(SYS:BYTE;W:LONGINT):STRING;
FUNCTION STRL(S:STRING;I:BYTE):STRING;
FUNCTION ISFILE(S:STRING):BOOLEAN;
FUNCTION HOCH(W,E:LONGINT):LONGINT;
FUNCTION GETNUMSTR(NUM:LONGINT):STRING;
FUNCTION ISNUM(SYS:BYTE;S:STRING):BOOLEAN;
FUNCTION UNSTR(SYS:BYTE;S:STRING):LONGINT;
IMPLEMENTATION
USES KCCM,OBJ2;
FUNCTION UNSTR(SYS:BYTE;S:STRING):LONGINT;
VAR W:LONGINT;
    I:BYTE;
    MULW:LONGINT;
BEGIN
 W:=0;
 MULW:=1;
 FOR I:=LENGTH(S) DOWNTO 1 DO
 BEGIN
  W:=W+UCH[BYTE(S[I])]*MULW;
  MULW:=MULW*SYS;
 END;
 UNSTR:=W;
END;
FUNCTION GETST(NUM,Z:LONGINT):BYTE;
BEGIN
 GETST:=NUM MOD HOCH(10,Z) DIV HOCH(10,Z-1);
END;
FUNCTION GETNUMH(NUM:LONGINT):STRING;
CONST NUMSTR1:ARRAY[0..9] OF STRING=(
       '',
       'ein',
       'zwei',
       'drei',
       'vier',
       'fnf',
       'sechs',
       'sieben',
       'acht',
       'neun');
      NUMSTR2:ARRAY[0..9] OF STRING=(
       '',
       'zehn',
       'zwanzig',
       'dreiig',
       'vierzig',
       'fnfzig',
       'sechszig',
       'siebzig',
       'achtzig',
       'neunzig');
      NUMSTR3:ARRAY[0..9] OF STRING=(
       '',
       'hundert',
       'zweihundert',
       'dreihundert',
       'vierhundert',
       'fnfhundert',
       'sechshundert',
       'siebenhundert',
       'achthundert',
       'neunhundert');
VAR S:STRING;
BEGIN
 IF NUM=0 THEN
 BEGIN
  GETNUMH:='';
 END
 ELSE
 BEGIN
  S:=NUMSTR3[GETST(NUM,3)]+NUMSTR1[GETST(NUM,1)];
  IF GETST(NUM,2)<>0 THEN
  BEGIN
   IF (GETST(NUM,1)<>0) AND (GETST(NUM,2)<>1) THEN
   BEGIN
    S:=S+'und'+NUMSTR2[GETST(NUM,2)];
   END
   ELSE
   BEGIN
    S:=S+NUMSTR2[GETST(NUM,2)];
   END;
  END;
  IF COPY(S,LENGTH(S)-6,7)='einzehn' THEN
  BEGIN
   DELETE(S,LENGTH(S)-6,7);
   S:=S+'elf';
  END;
  IF COPY(S,LENGTH(S)-7,8)='zweizehn' THEN
  BEGIN
   DELETE(S,LENGTH(S)-7,8);
   S:=S+'zwlf';
  END;
 END;
 GETNUMH:=S;
END;
FUNCTION GETNUMSTR(NUM:LONGINT):STRING;
CONST NUMSTR4:ARRAY[0..3,0..1] OF STRING=(
       ('',''),
       ('tausend','eintausend'),
       ('million','einemillion'),
       ('milliarden','einemilliarde'));
VAR S:STRING;
    ZP:BYTE;
BEGIN
 IF NUM=0 THEN
 BEGIN
  GETNUMSTR:='null';
  EXIT;
 END;
 S:=GETNUMH(NUM);
 ZP:=0;
 WHILE NUM>999 DO
 BEGIN
  INC(ZP);
  NUM:=NUM DIV 1000;
  IF NUM MOD 1000<>0 THEN
  BEGIN
   IF GETNUMH(NUM)='ein' THEN
   BEGIN
    S:=NUMSTR4[ZP,1]+S;
   END ELSE S:=GETNUMH(NUM)+NUMSTR4[ZP,0]+S;
  END;
 END;
 IF COPY(S,LENGTH(S)-2,3)='ein' THEN S:=S+'s';
 GETNUMSTR:=S;
END;
PROCEDURE TSTR.SETCHAR(X,Y:LONGINT;C:SYSTEM.CHAR);
VAR P:LONGINT;
BEGIN
 IF Y<=GETLINECOUNT THEN
 BEGIN
  P:=GETLINESTART(Y);
  IF GETLINELENGTH(Y)>X THEN
  BEGIN
   DELETE(P+X,1);
   INSERT(P+X,C);
  END;
 END;
END;
FUNCTION ISFILE(S:STRING):BOOLEAN;
VAR F:FILE;
BEGIN
 ASSIGN(F,S);
 SYSTEM.RESET(F,1);
 IF IORESULT=0 THEN
 BEGIN
  CLOSE(F);
  ISFILE:=TRUE;
 END ELSE ISFILE:=FALSE;
END;
DESTRUCTOR TCHARFILTER.SAVE(S:STRING);
VAR F:FILE;
BEGIN
 ASSIGN(F,S);
 REWRITE(F);
 IF IORESULT<>0 THEN EXIT;
 BLOCKWRITE(F,CH,256);
 CLOSE(F);
END;
CONSTRUCTOR TCHARFILTER.LOAD(S:STRING);
VAR F:FILE;
BEGIN
 ASSIGN(F,S);
 SYSTEM.RESET(F);
 IF (IORESULT<>0) OR (FILESIZE(F)<>256) THEN EXIT;
 BLOCKREAD(F,CH,256);
 CLOSE(F);
END;
PROCEDURE TCHARFILTER.FILL(S,L,C:BYTE);
VAR I:BYTE;
BEGIN
 IF L>255-S THEN L:=255-S;
 FOR I:=1 TO L DO CH[I+S-1]:=C;
END;
PROCEDURE TSTR.CLEAR;
BEGIN
 FILL:=0;
END;
FUNCTION TSTR.MEMFILL:LONGINT;ASSEMBLER;
ASM
  LES DI,[BP+6]
  MOV AX,WORD PTR ES:[DI+FILL]
  MOV DX,WORD PTR ES:[DI+FILL+2]
END;
FUNCTION TSTR.MEMFREE:LONGINT;ASSEMBLER;
ASM
  LES DI,[BP+6]
  MOV AX,WORD PTR ES:[DI+MAXLEN]
  MOV DX,WORD PTR ES:[DI+MAXLEN+2]
  SUB AX,WORD PTR ES:[DI+FILL]
  SBB DX,WORD PTR ES:[DI+FILL+2]
END;
PROCEDURE TSTR.ADD(S:STRING);
VAR I:BYTE;
BEGIN
 IF (FILL+LENGTH(S)>MAXLEN) THEN EXIT;
 SETINET;
 FOR I:=1 TO LENGTH(S) DO CHS[FILL+I-1]:=S[I];
 INC(FILL,LENGTH(S));
 CLEARINET;
END;
FUNCTION TSTR.LINEATPOS(P:LONGINT):LONGINT;ASSEMBLER;
ASM
  LES DI,[BP+6]
  LES DI,ES:[DI+CHS]
  DB 66h;MOV CX,WORD PTR P
  XOR AX,AX
 @LP:
  DB 66h;DEC CX
  JS @EXT
  MOV BL,ES:[DI]
  SUB BL,13
  JNZ @LP
  INC AX
  JMP @LP
 @EXT:
  XOR DX,DX
END;
FUNCTION TSTR.GETLINEAT(VAR P:LONGINT):STRING;
VAR LP:LONGINT;
    S:STRING;
BEGIN
 LP:=P;
 S:='';
 WHILE (CHS[LP]<>#13) AND (LP<FILL) DO
 BEGIN
  IF CHS[LP]<>#0 THEN S:=S+CHS[LP];
  INC(LP);
 END;
 P:=LP+1;
 GETLINEAT:=S;
END;
PROCEDURE TSTR.SAVE(S:STRING);
VAR F:TEXT;
    P:LONGINT;
BEGIN
 SETINET;
 P:=0;
 ASSIGN(F,S);
 REWRITE(F);
 S:='';
 WHILE P<FILL DO
 BEGIN
  IF CHS[P]=#13 THEN
  BEGIN
   WRITELN(F,S);
   S:='';
  END
  ELSE
  BEGIN
   S:=S+CHS[P];
  END;
  INC(P);
 END;
 IF LENGTH(S)>0 THEN WRITE(F,S);
 CLOSE(F);
 CLEARINET;
END;
PROCEDURE TSTR.LOAD(S:STRING);
VAR F:TEXT;
    I,P:LONGINT;
BEGIN
 WINU.SETINET;
 SYSTEM.ASSIGN(F,S);
 SYSTEM.RESET(F);
 IF IORESULT<>0 THEN
 BEGIN
  CLEARINET;
  EXIT;
 END;
 FILL:=0;
 P:=0;
 WHILE NOT EOF(F) DO
 BEGIN
  READLN(F,S);
  FOR I:=1 TO LENGTH(S) DO
  BEGIN
   CHS[P]:=S[I];
   INC(P);
  END;
  IF NOT EOF(F) THEN
  BEGIN
   CHS[P]:=#13;
   INC(P);
  END;
 END;
 CLOSE(F);
 FILL:=P;
 CLEARINET;
END;
FUNCTION TSTR.GETLINESTART(L:LONGINT):LONGINT;ASSEMBLER;
ASM
  LES DI,[BP+6]
  DB 66h;MOV BX,WORD PTR ES:[DI+FILL]
  LES DI,ES:[DI+CHS]
  XOR AX,AX
  DB 66h;MOV DX,WORD PTR L
  DB 66h;DEC DX
  JS @EXT
 @LP:
  DB 66h;DEC BX
  JS @EXT
  MOV CL,ES:[DI]
  INC DI
  INC AX
  SUB CL,13
  JNZ @LP
  DB 66h;DEC DX
  JNS @LP
 @EXT:
  XOR DX,DX
END;
FUNCTION TSTR.GETLINEEND(L:LONGINT):LONGINT;ASSEMBLER;
ASM
  LES DI,[BP+6]
  DB 66h;MOV BX,WORD PTR ES:[DI+FILL]
  LES DI,ES:[DI+CHS]
  XOR AX,AX
  DB 66h;MOV DX,WORD PTR L
  DB 66h;DEC DX
  JS @TOEND
 @LP:
  DB 66h;DEC BX
  JS @EXT
  INC DI
  INC AX
  MOV CL,ES:[DI]
  SUB CL,13
  JNZ @LP
  DB 66h;DEC DX
  JNS @LP
 @TOEND:
  DB 66h;DEC BX
  JS @EXT
  INC DI
  INC AX
  MOV CL,ES:[DI]
  CMP CL,13
  JNZ @TOEND
 @EXT:
  XOR DX,DX
END;
FUNCTION TSTR.GETLINELENGTH(L:LONGINT):LONGINT;
VAR P,C:LONGINT;
BEGIN
 P:=0;
 C:=0;
 WHILE (C<L) DO
 BEGIN
  WHILE (CHS[P]<>#13) AND (P<FILL) DO INC(P);
  INC(P);
  INC(C);
 END;
 C:=0;
 WHILE (CHS[P]<>#13) AND (P<FILL) DO
 BEGIN
  INC(C);
  INC(P);
 END;
 GETLINELENGTH:=C;
END;
FUNCTION TSTR.GETLINECOUNT:LONGINT;ASSEMBLER;
ASM
  LES DI,[BP+6]
  DB 66h;MOV CX,WORD PTR ES:[DI+FILL]
  LES DI,ES:[DI+CHS]
  MOV AX,1
  DEC DI
 @LP:
  DB 66h;DEC CX
  JS @EXT
  INC DI
  MOV BL,ES:[DI]
  SUB BL,13
  JNZ @LP
  INC AX
  JMP @LP
 @EXT:
  XOR DX,DX
END;
FUNCTION TSTR.GETLINE(N:WORD):STRING;
VAR P,LC:LONGINT;
    RES:STRING;
BEGIN
 LC:=0;
 P:=0;
 WHILE (LC<N) DO
 BEGIN
  WHILE (CHS[P]<>#13) DO
  BEGIN
   IF P=FILL THEN
   BEGIN
    GETLINE:='';
    EXIT;
   END;
   INC(P);
  END;
  INC(LC);
  INC(P);
 END;
 RES:='';
 WHILE (CHS[P]<>#13) AND (P<FILL) DO
 BEGIN
  IF CHS[P]<>#10 THEN RES:=RES+CHS[P];
  INC(P);
 END;
 GETLINE:=RES;
END;
PROCEDURE TSTR.DELETE(P,C:LONGINT);
VAR I:LONGINT;
BEGIN
 IF (P>=FILL) OR (C=0) OR (FILL<C) THEN EXIT;
 SETINET;
 IF FILL-P-C<0 THEN C:=FILL-P+1;
 FOR I:=P TO FILL DO CHS[I]:=CHS[I+C];
 DEC(FILL,C);
 CLEARINET;
END;
PROCEDURE TSTR.INSERT(P:LONGINT;S:STRING);
VAR I:LONGINT;
BEGIN
 IF (FILL+LENGTH(S)>MAXLEN) THEN EXIT;
 SETINET;
 IF (P>FILL) THEN P:=FILL;
 FOR I:=FILL+LENGTH(S) DOWNTO P+LENGTH(S) DO CHS[I]:=CHS[I-LENGTH(S)];
 FOR I:=1 TO LENGTH(S) DO CHS[P+I-1]:=S[I];
 INC(FILL,LENGTH(S));
 CLEARINET;
END;
DESTRUCTOR TSTR.DONE;
BEGIN
 IF CHS<>NIL THEN FREEMEM(CHS,MAXLEN);
END;
CONSTRUCTOR TSTR.INIT(ML:LONGINT);
BEGIN
 GETMEM(CHS,ML);
 IF CHS=NIL THEN FAIL;
 FILL:=0;
 MAXLEN:=ML;
END;
PROCEDURE TPTLIST.ADDS(P:POINTER);
VAR P2:PPTLIST_I;
BEGIN
 NEW(P2);
 P2^.LAST:=NIL;
 P2^.NEXT:=FIRST;
 FIRST^.LAST:=P2;
 FIRST:=P2;
END;
PROCEDURE TPTLIST.ADD(P:POINTER);
VAR P2:PPTLIST_I;
BEGIN
 SETINET;
 IF COUNT=0 THEN
 BEGIN
  NEW(FIRST);
  FIRST^.NEXT:=NIL;
  FIRST^.LAST:=NIL;
  FIRST^.PT:=P;
  INC(COUNT);
 END
 ELSE
 BEGIN
  P2:=FIRST;
  WHILE P2^.NEXT<>NIL DO P2:=P2^.NEXT;
  NEW(P2^.NEXT);
  P2^.NEXT^.LAST:=P2;
  P2^.NEXT^.NEXT:=NIL;
  P2^.NEXT^.PT:=P;
  INC(COUNT);
 END;
 CLEARINET;
END;
FUNCTION TPTLIST.GET(IP:LONGINT):POINTER;
VAR P:PPTLIST_I;
    I:LONGINT;
BEGIN
 IF IP>=COUNT THEN
 BEGIN
  GET:=NIL;
  EXIT;
 END;
 P:=FIRST;
 FOR I:=1 TO IP DO P:=P^.NEXT;
 GET:=P^.PT;
END;
FUNCTION TPTLIST.GETCOUNT:LONGINT;
BEGIN
 GETCOUNT:=COUNT;
END;
PROCEDURE TPTLIST.DELETE(IP:LONGINT);
VAR P:PPTLIST_I;
    I:LONGINT;
BEGIN
 IF COUNT=0 THEN EXIT;
 SETINET;
 IF IP>=COUNT THEN IP:=COUNT-1;
 IF IP=0 THEN
 BEGIN
  P:=FIRST^.NEXT;
  DISPOSE(FIRST);
  FIRST:=P;
  P^.LAST:=NIL;
  DEC(COUNT);
 END
 ELSE
 BEGIN
  P:=FIRST;
  FOR I:=1 TO IP DO P:=P^.NEXT;
  P^.LAST^.NEXT:=P^.NEXT;
  IF P^.NEXT<>NIL THEN P^.NEXT^.LAST:=P^.LAST;
  DISPOSE(P);
 END;
 CLEARINET;
END;
PROCEDURE TPTLIST.INSERT(IP:LONGINT;P:POINTER);
VAR PT,P2:PPTLIST_I;
    I:LONGINT;
BEGIN
 SETINET;
 IF IP>=COUNT THEN IP:=COUNT-1;
 IF IP=0 THEN
 BEGIN
  PT:=FIRST;
  NEW(FIRST);
  FIRST^.NEXT:=PT;
  FIRST^.LAST:=NIL;
  PT^.LAST:=FIRST;
  FIRST^.PT:=P;
  INC(COUNT);
 END
 ELSE
 BEGIN
  PT:=FIRST;
  FOR I:=2 TO IP DO PT:=PT^.NEXT;
  NEW(P2);
  P2^.NEXT:=PT^.NEXT;
  P2^.LAST:=PT;
  IF PT^.NEXT<>NIL THEN PT^.NEXT^.LAST:=P2;
  PT^.NEXT:=P2;
  P2^.PT:=P;
 END;
 CLEARINET;
END;
PROCEDURE TPTLIST.CLEAR;
VAR P,P2:PPTLIST_I;
BEGIN
 SETINET;
 P:=FIRST;
 WHILE P<>NIL DO
 BEGIN
  P2:=P^.NEXT;
  DISPOSE(P);
  P:=P2;
 END;
 FIRST:=NIL;
 COUNT:=0;
 CLEARINET;
END;
DESTRUCTOR TPTLIST.DONE;
VAR P,P2:PPTLIST_I;
BEGIN
 P:=FIRST;
 WHILE P<>NIL DO
 BEGIN
  P2:=P^.NEXT;
  DISPOSE(P);
  P:=P2;
 END;
END;
CONSTRUCTOR TPTLIST.INIT;
BEGIN
 FIRST:=NIL;
 COUNT:=0;
END;
FUNCTION STRL(S:STRING;I:BYTE):STRING;
BEGIN
 WHILE LENGTH(S)<I DO S:=' '+S;
 STRL:=S;
END;
FUNCTION NEEDS(SYS:BYTE;W:LONGINT):BYTE;
VAR I:BYTE;
    R:LONGINT;
BEGIN
 R:=SYS;
 I:=1;
 WHILE W>=R DO
 BEGIN
  R:=R*SYS;
  INC(I);
 END;
 NEEDS:=I;
END;
FUNCTION HOCH(W,E:LONGINT):LONGINT;
VAR I,N:LONGINT;
BEGIN
 IF E=0 THEN
 BEGIN
  HOCH:=1;
  EXIT;
 END;
 N:=W;
 FOR I:=2 TO E DO N:=N*W;
 HOCH:=N;
END;
FUNCTION ISNUM(SYS:BYTE;S:STRING):BOOLEAN;
VAR I:BYTE;
BEGIN
 FOR I:=1 DOWNTO LENGTH(S) DO
 BEGIN
  IF UCH[BYTE(S[I])]>SYS-1 THEN
  BEGIN
   ISNUM:=FALSE;
   EXIT;
  END;
 END;
 ISNUM:=TRUE;
END;
FUNCTION NUMSTR(SYS:BYTE;W:LONGINT):STRING;
VAR I:BYTE;
    S:STRING;
    H,N:LONGINT;
BEGIN
 S:='';
 N:=NEEDS(SYS,W)-1;
 H:=HOCH(SYS,N);
 FOR I:=N DOWNTO 0 DO
 BEGIN
  S:=S+CHA[(W MOD (H*SYS)) DIV H];
  H:=H DIV SYS;
 END;
 NUMSTR:=S;
END;
END.