UNIT OBJ4;
INTERFACE
USES MODE3,WINU,KEYB,MOUSE,TASREC;
TYPE PFIELDEDIT_TOOL=^TFIELDEDIT_TOOL;
     PFIELDEDIT=^TFIELDEDIT;
     TFIELDEDIT=OBJECT(TWIN)
      PRIVATE
      FIELD:PCHARPIC;
      AKTTOOL:PFIELDEDIT_TOOL;
      PUBLIC
      FUNCTION GETFIELD:PCHARPIC;
      CONSTRUCTOR INIT(BAS:PWIN;X,Y:INTEGER;H,B:WORD);
      DESTRUCTOR DONE;
      FUNCTION MOUSE:BOOLEAN;VIRTUAL;
      PROCEDURE PAINT;VIRTUAL;
      PROCEDURE SETTOOL(P:PFIELDEDIT_TOOL);
      PROCEDURE UNSETTOOL(P:PFIELDEDIT_TOOL);
     END;
     TFIELDEDIT_TOOL=OBJECT
      PRIVATE
      ZOBJ:PFIELDEDIT;
      FC,BC:PETRCA;
      PUBLIC
      FUNCTION GETFRONT:PETRCA;
      FUNCTION GETBACK:PETRCA;
      FUNCTION GETOBJ:PFIELDEDIT;
      FUNCTION GETFIELD:PCHARPIC;
      CONSTRUCTOR INIT(P:PFIELDEDIT;C1,C2:PETRCA);
      DESTRUCTOR DONE;
      PROCEDURE USE;
      PROCEDURE GIVECOR(PX,PY,PB:INTEGER;CIN:BOOLEAN);VIRTUAL;
      PROCEDURE PAINT;VIRTUAL;
     END;
IMPLEMENTATION
FUNCTION TFIELDEDIT_TOOL.GETFRONT:PETRCA;
BEGIN
 GETFRONT:=FC;
END;
FUNCTION TFIELDEDIT_TOOL.GETBACK:PETRCA;
BEGIN
 GETBACK:=BC;
END;
FUNCTION TFIELDEDIT.GETFIELD:PCHARPIC;
BEGIN
 GETFIELD:=FIELD;
END;
FUNCTION TFIELDEDIT_TOOL.GETFIELD:PCHARPIC;
BEGIN
 GETFIELD:=ZOBJ^.GETFIELD;
END;
FUNCTION TFIELDEDIT_TOOL.GETOBJ:PFIELDEDIT;
BEGIN
 GETOBJ:=ZOBJ;
END;
PROCEDURE TFIELDEDIT_TOOL.GIVECOR(PX,PY,PB:INTEGER;CIN:BOOLEAN);
BEGIN
END;
PROCEDURE TFIELDEDIT_TOOL.PAINT;
BEGIN
END;
PROCEDURE TFIELDEDIT_TOOL.USE;
BEGIN
 ZOBJ^.SETTOOL(@SELF);
END;
DESTRUCTOR TFIELDEDIT_TOOL.DONE;
BEGIN
 ZOBJ^.UNSETTOOL(@SELF);
END;
CONSTRUCTOR TFIELDEDIT_TOOL.INIT(P:PFIELDEDIT;C1,C2:PETRCA);
BEGIN
 ZOBJ:=P;
 FC:=C1;
 BC:=C2;
END;
PROCEDURE TFIELDEDIT.UNSETTOOL(P:PFIELDEDIT_TOOL);
BEGIN
 IF AKTTOOL=P THEN AKTTOOL:=NIL;
END;
PROCEDURE TFIELDEDIT.SETTOOL(P:PFIELDEDIT_TOOL);
BEGIN
 AKTTOOL:=P;
END;
DESTRUCTOR TFIELDEDIT.DONE;
BEGIN
 DISPOSE(FIELD,DONE);
 INHERITED DONE;
END;
CONSTRUCTOR TFIELDEDIT.INIT(BAS:PWIN;X,Y:INTEGER;H,B:WORD);
VAR S:STRING;
    I:SYSTEM.BYTE;
BEGIN
 INHERITED INIT(BAS,X,Y,H,B,TRUE,FALSE);
 SYSTEM.NEW(FIELD,INIT(H,B));
 AKTTOOL:=NIL;
END;
FUNCTION TFIELDEDIT.MOUSE:BOOLEAN;
VAR X,Y:INTEGER;
    H,B:WORD;
BEGIN
 IF CIN THEN
 BEGIN
  MOUSE:=TRUE;
  IF NOT ISANYFOCUS THEN
  BEGIN
   IF (CDB AND 127>0) AND (NOT COTHER) AND (NOT CUNDER) AND (NOT ISFOCUS) THEN
   BEGIN
    FOCUS;
   END;
  END
  ELSE
  BEGIN
   IF (CDB AND 127>0) AND (NOT COTHER) AND (NOT CUNDER) AND GETTHEFOCUS^.FREEFOCUS(@SELF) AND (NOT ISFOCUS) THEN
   BEGIN
    FOCUS;
   END;
  END;
 END ELSE MOUSE:=FALSE;
 IF ISFOCUS THEN
 BEGIN
  IF AKTTOOL<>NIL THEN AKTTOOL^.GIVECOR(CDX,CDY,CDB,CIN);
 END;
END;
PROCEDURE TFIELDEDIT.PAINT;
BEGIN
 FIELD^.PUTONSCREEN(0,0);
 IF AKTTOOL<>NIL THEN AKTTOOL^.PAINT;
 IF CIN AND (NOT COTHER) THEN MODE3.PUT(CDX,CDY,GETC(CDX,CDY),NOT (GETA(CDX,CDY)) OR 128);
END;
END.