UNIT OBJ5;
INTERFACE
USES MODE3,OBJ4;
TYPE PFIELDEDIT_PUTPIXEL=^TFIELDEDIT_PUTPIXEL;
     TFIELDEDIT_PUTPIXEL=OBJECT(TFIELDEDIT_TOOL)
      PROCEDURE GIVECOR(X,Y,B:INTEGER;CIN:BOOLEAN);VIRTUAL;
     END;
TYPE PFIELDEDIT_RECTANGLE=^TFIELDEDIT_RECTANGLE;
     TFIELDEDIT_RECTANGLE=OBJECT(TFIELDEDIT_TOOL)
      PRIVATE
      SX,SY,SB,NX,NY,H,B:INTEGER;
      DOWN:BOOLEAN;
      PUBLIC
      CONSTRUCTOR INIT(P:PFIELDEDIT;C1,C2:PETRCA);
      PROCEDURE GIVECOR(PX,PY,PB:INTEGER;CIN:BOOLEAN);VIRTUAL;
      PROCEDURE PAINT;VIRTUAL;
     END;
TYPE PFIELDEDIT_LINE=^TFIELDEDIT_LINE;
     TFIELDEDIT_LINE=OBJECT(TFIELDEDIT_TOOL)
      PRIVATE
      SX,SY,SB,NX,NY:INTEGER;
      DOWN:BOOLEAN;
      PUBLIC
      CONSTRUCTOR INIT(P:PFIELDEDIT;C1,C2:PETRCA);
      PROCEDURE GIVECOR(PX,PY,PB:INTEGER;CIN:BOOLEAN);VIRTUAL;
      PROCEDURE PAINT;VIRTUAL;
     END;
TYPE PFIELDEDIT_BAR=^TFIELDEDIT_BAR;
     TFIELDEDIT_BAR=OBJECT(TFIELDEDIT_TOOL)
      PRIVATE
      SX,SY,SB,NX,NY,H,B:INTEGER;
      DOWN:BOOLEAN;
      PUBLIC
      CONSTRUCTOR INIT(P:PFIELDEDIT;C1,C2:PETRCA);
      PROCEDURE GIVECOR(PX,PY,PB:INTEGER;CIN:BOOLEAN);VIRTUAL;
      PROCEDURE PAINT;VIRTUAL;
     END;
TYPE PFIELDEDIT_DOUBLEBOX=^TFIELDEDIT_DOUBLEBOX;
     TFIELDEDIT_DOUBLEBOX=OBJECT(TFIELDEDIT_TOOL)
      PRIVATE
      SX,SY,SB,NX,NY,H,B:INTEGER;
      DOWN:BOOLEAN;
      PUBLIC
      CONSTRUCTOR INIT(P:PFIELDEDIT;C1,C2:PETRCA);
      PROCEDURE GIVECOR(PX,PY,PB:INTEGER;CIN:BOOLEAN);VIRTUAL;
      PROCEDURE PAINT;VIRTUAL;
     END;
TYPE PFIELDEDIT_SINGLEBOX=^TFIELDEDIT_SINGLEBOX;
     TFIELDEDIT_SINGLEBOX=OBJECT(TFIELDEDIT_TOOL)
      PRIVATE
      SX,SY,SB,NX,NY,H,B:INTEGER;
      DOWN:BOOLEAN;
      PUBLIC
      CONSTRUCTOR INIT(P:PFIELDEDIT;C1,C2:PETRCA);
      PROCEDURE GIVECOR(PX,PY,PB:INTEGER;CIN:BOOLEAN);VIRTUAL;
      PROCEDURE PAINT;VIRTUAL;
     END;
IMPLEMENTATION
PROCEDURE TFIELDEDIT_PUTPIXEL.GIVECOR(X,Y,B:INTEGER;CIN:BOOLEAN);
BEGIN
 IF CIN THEN
 BEGIN
  IF B=1 THEN GETFIELD^.PUTSTYLE(X,Y,GETFRONT);
  IF B=2 THEN GETFIELD^.PUTSTYLE(X,Y,GETBACK);
 END;
END;
CONSTRUCTOR TFIELDEDIT_BAR.INIT(P:PFIELDEDIT;C1,C2:PETRCA);
BEGIN
 INHERITED INIT(P,C1,C2);
 DOWN:=FALSE;
END;
PROCEDURE TFIELDEDIT_BAR.PAINT;
BEGIN
 IF DOWN THEN
 BEGIN
  IF SB=1 THEN BARSTYLE(NX,NY,H,B,GETFRONT);
  IF SB=2 THEN BARSTYLE(NX,NY,H,B,GETBACK);
 END;
END;
PROCEDURE TFIELDEDIT_BAR.GIVECOR(PX,PY,PB:INTEGER;CIN:BOOLEAN);
BEGIN
 IF DOWN THEN
 BEGIN
  IF PX<SX THEN
  BEGIN
   NX:=PX;
   B:=SX-PX+1;
  END
  ELSE
  BEGIN
   NX:=SX;
   B:=PX-SX+1;
  END;
  IF PY<SY THEN
  BEGIN
   NY:=PY;
   H:=SY-PY+1;
  END
  ELSE
  BEGIN
   NY:=SY;
   H:=PY-SY+1;
  END;
  IF PB=0 THEN
  BEGIN
   IF SB=1 THEN GETFIELD^.BARSTYLE(NX,NY,H,B,GETFRONT);
   IF SB=2 THEN GETFIELD^.BARSTYLE(NX,NY,H,B,GETBACK);
   DOWN:=FALSE;
  END;
 END
 ELSE
 BEGIN
  IF ((PB=1) OR (PB=2)) AND CIN THEN
  BEGIN
   SX:=PX;
   SY:=PY;
   SB:=PB;
   NX:=PX;
   NY:=PY;
   H:=1;
   B:=1;
   DOWN:=TRUE;
  END;
 END;
END;
CONSTRUCTOR TFIELDEDIT_LINE.INIT(P:PFIELDEDIT;C1,C2:PETRCA);
BEGIN
 INHERITED INIT(P,C1,C2);
 DOWN:=FALSE;
END;
PROCEDURE TFIELDEDIT_LINE.PAINT;
BEGIN
 IF DOWN THEN
 BEGIN
  IF SB=1 THEN LINESTYLE(SX,SY,NX,NY,GETFRONT);
  IF SB=2 THEN LINESTYLE(SX,SY,NX,NY,GETBACK);
 END;
END;
PROCEDURE TFIELDEDIT_LINE.GIVECOR(PX,PY,PB:INTEGER;CIN:BOOLEAN);
BEGIN
 IF DOWN THEN
 BEGIN
  NX:=PX;
  NY:=PY;
  IF PB=0 THEN
  BEGIN
   IF SB=1 THEN GETFIELD^.LINESTYLE(SX,SY,NX,NY,GETFRONT);
   IF SB=2 THEN GETFIELD^.LINESTYLE(SX,SY,NX,NY,GETBACK);
   DOWN:=FALSE;
  END;
 END
 ELSE
 BEGIN
  IF ((PB=1) OR (PB=2)) AND CIN THEN
  BEGIN
   SX:=PX;
   SY:=PY;
   SB:=PB;
   NX:=PX;
   NY:=PY;
   DOWN:=TRUE;
  END;
 END;
END;
CONSTRUCTOR TFIELDEDIT_RECTANGLE.INIT(P:PFIELDEDIT;C1,C2:PETRCA);
BEGIN
 INHERITED INIT(P,C1,C2);
 DOWN:=FALSE;
END;
PROCEDURE TFIELDEDIT_RECTANGLE.PAINT;
BEGIN
 IF DOWN THEN
 BEGIN
  IF SB=1 THEN RECTANGLESTYLE(NX,NY,H,B,GETFRONT);
  IF SB=2 THEN RECTANGLESTYLE(NX,NY,H,B,GETBACK);
 END;
END;
PROCEDURE TFIELDEDIT_RECTANGLE.GIVECOR(PX,PY,PB:INTEGER;CIN:BOOLEAN);
BEGIN
 IF DOWN THEN
 BEGIN
  IF PX<SX THEN
  BEGIN
   NX:=PX;
   B:=SX-PX+1;
  END
  ELSE
  BEGIN
   NX:=SX;
   B:=PX-SX+1;
  END;
  IF PY<SY THEN
  BEGIN
   NY:=PY;
   H:=SY-PY+1;
  END
  ELSE
  BEGIN
   NY:=SY;
   H:=PY-SY+1;
  END;
  IF PB=0 THEN
  BEGIN
   IF SB=1 THEN GETFIELD^.RECTANGLESTYLE(NX,NY,H,B,GETFRONT);
   IF SB=2 THEN GETFIELD^.RECTANGLESTYLE(NX,NY,H,B,GETBACK);
   DOWN:=FALSE;
  END;
 END
 ELSE
 BEGIN
  IF ((PB=1) OR (PB=2)) AND CIN THEN
  BEGIN
   SX:=PX;
   SY:=PY;
   SB:=PB;
   NX:=PX;
   NY:=PY;
   H:=1;
   B:=1;
   DOWN:=TRUE;
  END;
 END;
END;
CONSTRUCTOR TFIELDEDIT_DOUBLEBOX.INIT(P:PFIELDEDIT;C1,C2:PETRCA);
BEGIN
 INHERITED INIT(P,C1,C2);
 DOWN:=FALSE;
END;
PROCEDURE TFIELDEDIT_DOUBLEBOX.PAINT;
BEGIN
 IF DOWN THEN
 BEGIN
  IF SB=1 THEN DOUBLEBOX(NX,NY,H,B,GETFRONT^.A);
  IF SB=2 THEN DOUBLEBOX(NX,NY,H,B,GETBACK^.A);
 END;
END;
PROCEDURE TFIELDEDIT_DOUBLEBOX.GIVECOR(PX,PY,PB:INTEGER;CIN:BOOLEAN);
BEGIN
 IF DOWN THEN
 BEGIN
  IF PX<SX THEN
  BEGIN
   NX:=PX;
   B:=SX-PX+1;
  END
  ELSE
  BEGIN
   NX:=SX;
   B:=PX-SX+1;
  END;
  IF PY<SY THEN
  BEGIN
   NY:=PY;
   H:=SY-PY+1;
  END
  ELSE
  BEGIN
   NY:=SY;
   H:=PY-SY+1;
  END;
  IF PB=0 THEN
  BEGIN
   IF SB=1 THEN GETFIELD^.DOUBLEBOX(NX,NY,H,B,GETFRONT^.A);
   IF SB=2 THEN GETFIELD^.DOUBLEBOX(NX,NY,H,B,GETBACK^.A);
   DOWN:=FALSE;
  END;
 END
 ELSE
 BEGIN
  IF ((PB=1) OR (PB=2)) AND CIN THEN
  BEGIN
   SX:=PX;
   SY:=PY;
   SB:=PB;
   NX:=PX;
   NY:=PY;
   H:=1;
   B:=1;
   DOWN:=TRUE;
  END;
 END;
END;
CONSTRUCTOR TFIELDEDIT_SINGLEBOX.INIT(P:PFIELDEDIT;C1,C2:PETRCA);
BEGIN
 INHERITED INIT(P,C1,C2);
 DOWN:=FALSE;
END;
PROCEDURE TFIELDEDIT_SINGLEBOX.PAINT;
BEGIN
 IF DOWN THEN
 BEGIN
  IF SB=1 THEN SINGLEBOX(NX,NY,H,B,GETFRONT^.A);
  IF SB=2 THEN SINGLEBOX(NX,NY,H,B,GETBACK^.A);
 END;
END;
PROCEDURE TFIELDEDIT_SINGLEBOX.GIVECOR(PX,PY,PB:INTEGER;CIN:BOOLEAN);
BEGIN
 IF DOWN THEN
 BEGIN
  IF PX<SX THEN
  BEGIN
   NX:=PX;
   B:=SX-PX+1;
  END
  ELSE
  BEGIN
   NX:=SX;
   B:=PX-SX+1;
  END;
  IF PY<SY THEN
  BEGIN
   NY:=PY;
   H:=SY-PY+1;
  END
  ELSE
  BEGIN
   NY:=SY;
   H:=PY-SY+1;
  END;
  IF PB=0 THEN
  BEGIN
   IF SB=1 THEN GETFIELD^.SINGLEBOX(NX,NY,H,B,GETFRONT^.A);
   IF SB=2 THEN GETFIELD^.SINGLEBOX(NX,NY,H,B,GETBACK^.A);
   DOWN:=FALSE;
  END;
 END
 ELSE
 BEGIN
  IF ((PB=1) OR (PB=2)) AND CIN THEN
  BEGIN
   SX:=PX;
   SY:=PY;
   SB:=PB;
   NX:=PX;
   NY:=PY;
   H:=1;
   B:=1;
   DOWN:=TRUE;
  END;
 END;
END;
END.