PROGRAM CALC8D;
USES KCCM,WINU,KEYB,NUMCONV,OBJ1;
TYPE FIELD=ARRAY[0..7] OF BYTE;
TYPE PLOESUNG=^TLOESUNG;
     TLOESUNG=RECORD
      FLD:FIELD;
      NEXT:PLOESUNG;
     END;
VAR LIN,POS:FIELD;
    FLO:PLOESUNG;
    DOUBLE:STRING;
    TABL:WORD;
FUNCTION SAMFLD(V1,V2:FIELD):BOOLEAN;
VAR I:BYTE;
BEGIN
 FOR I:=0 TO 7 DO
 BEGIN
  IF V1[I]<>V2[I] THEN
  BEGIN
   SAMFLD:=FALSE;
   EXIT;
  END;
 END;
 SAMFLD:=TRUE;
END;
PROCEDURE SPV(P:FIELD;VAR P2:FIELD);
VAR I:BYTE;
BEGIN
 FOR I:=0 TO 7 DO
 BEGIN
  P2[7-I]:=P[I];
 END;
END;
PROCEDURE SPH(P:FIELD;VAR P2:FIELD);
VAR I:BYTE;
BEGIN
 FOR I:=0 TO 7 DO
 BEGIN
  P2[I]:=7-P[I];
 END;
END;
PROCEDURE ROT(P:FIELD;VAR P2:FIELD);
VAR I:BYTE;
BEGIN
 FOR I:=0 TO 7 DO
 BEGIN
  P2[P[I]]:=7-I;
 END;
END;
FUNCTION GLOESUNG:BOOLEAN;
VAR P:PLOESUNG;
    RO,SP:FIELD;
    E:BOOLEAN;
    PP:WORD;
BEGIN
 DOUBLE:='';
 P:=FLO;
 E:=TRUE;
 PP:=TABL+1;
 WHILE P<>NIL DO
 BEGIN
  DEC(PP);
  RO:=P^.FLD;
  SPV(RO,SP);
  IF SAMFLD(POS,SP) THEN
  BEGIN
   DOUBLE:=DOUBLE+'*V'+NUMSTR(10,PP)+'*';
   E:=FALSE;
  END;
  SPH(SP,SP);
  IF SAMFLD(POS,SP) THEN
  BEGIN
   DOUBLE:=DOUBLE+'*HV'+NUMSTR(10,PP)+'*';
   E:=FALSE;
  END;
  SPH(RO,SP);
  IF SAMFLD(POS,SP) THEN
  BEGIN
   DOUBLE:=DOUBLE+'*H'+NUMSTR(10,PP)+'*';
   E:=FALSE;
  END;
  ROT(RO,RO);
  IF SAMFLD(POS,RO) THEN
  BEGIN
   DOUBLE:=DOUBLE+'*R'+NUMSTR(10,PP)+'*';
   E:=FALSE;
  END;
  SPV(RO,SP);
  IF SAMFLD(POS,SP) THEN
  BEGIN
   DOUBLE:=DOUBLE+'*RV'+NUMSTR(10,PP)+'*';
   E:=FALSE;
  END;
  SPH(SP,SP);
  IF SAMFLD(POS,SP) THEN
  BEGIN
   DOUBLE:=DOUBLE+'*RHV'+NUMSTR(10,PP)+'*';
   E:=FALSE;
  END;
  SPH(RO,SP);
  IF SAMFLD(POS,SP) THEN
  BEGIN
   DOUBLE:=DOUBLE+'*RH'+NUMSTR(10,PP)+'*';
   E:=FALSE;
  END;
  P:=P^.NEXT;
 END;
 IF NOT E THEN
 BEGIN
  GLOESUNG:=FALSE;
  EXIT;
 END;
 P:=FLO;
 SETINET;
 NEW(FLO);
 CLEARINET;
 FLO^.FLD:=POS;
 FLO^.NEXT:=P;
 INC(TABL);
END;
FUNCTION ISDAME(I,N:BYTE):BOOLEAN;ASSEMBLER;
ASM
  XOR AX,AX
  XOR BX,BX
  MOV BL,I
  CMP BL,7
  JA @RETFAL
  MOV BL,BYTE PTR [POS+BX]
  CMP BL,N
  JNZ @RETFAL
  INC AX
 @RETFAL:
END;
VAR WL:PWINEDIT;
    TXTMSG:PTEXT;
    LP,NUM,GNUM:WORD;
    E:BOOLEAN;
    I,N:SHORTINT;
    L1,L2:WORD;
PROCEDURE SCAN;
BEGIN
 WHILE 1=1 DO
 BEGIN
  REPEAT
   I:=0;
   WHILE I<8 DO
   BEGIN
    IF POS[I]<7 THEN
    BEGIN
     DEC(LIN[POS[I]]);
     INC(POS[I]);
     INC(LIN[POS[I]]);
     I:=8;
    END
    ELSE
    BEGIN
     DEC(LIN[7]);
     POS[I]:=0;
     INC(LIN[0]);
     INC(I);
     IF I=8 THEN
     BEGIN
      LP:=65535;
      WL^.ADD('Lsungen Insgesammt :'+NUMSTR(10,NUM)+'  davon Grundlsungen :'+NUMSTR(10,GNUM));
      TXTMSG^.SETTEXT('100% Prozent berechnet...(Programm mit [ESC] beenden !)');
      EXIT;
     END;
    END;
   END;
   E:=TRUE;
   FOR I:=0 TO 7 DO
   BEGIN
    IF LIN[I]>1 THEN E:=FALSE;
   END;
   IF LP<>POS[7]*8+POS[6] THEN
   BEGIN
    LP:=POS[7]*8+POS[6];
    TXTMSG^.SETTEXT(NUMSTR(10,ROUND(LP/(64/100)))+'% Prozent berechnet...(mit [ESC] abbrechen)');
   END;
  UNTIL E;
  IF AKTKEY=KEY_SPECIAL_ESC THEN
  BEGIN
   TXTMSG^.SETTEXT(NUMSTR(10,ROUND(LP/(64/100)))+'% Prozent berechnet...(Program mit [ESC] beenden/[RETURN] fortsetzen)');
   EXIT;
  END;
  FOR I:=-7 TO 14 DO
  BEGIN
   L1:=0;
   L2:=0;
   FOR N:=0 TO 7 DO
   BEGIN
    L1:=L1+ORD(ISDAME(I+N,N));
    L2:=L2+ORD(ISDAME(I+(7-N),N));
   END;
   IF (L1>1) OR (L2>1) THEN
   BEGIN
    E:=FALSE;
    BREAK;
   END;
  END;
  IF E THEN
  BEGIN
   INC(NUM);
   IF GLOESUNG THEN
   BEGIN
    INC(GNUM);
    WL^.ADD('Lsung Nr.'+NUMSTR(10,NUM)+' (Grundlsung Nr.'+NUMSTR(10,GNUM)+')'+#13);
   END
   ELSE
   BEGIN
    WL^.ADD('Lsung Nr.'+NUMSTR(10,NUM)+' (keine Grundlsung'+DOUBLE+')'+#13);
   END;
   WL^.ADD('        1  2  3  4  5  6  7  8'+#13);
   WL^.ADD('       ͻ'+#13);
   FOR I:=0 TO 7 DO
   BEGIN
    WL^.ADD('     '+NUMSTR(10,I+1)+' ');
    FOR N:=0 TO 7 DO
    BEGIN
     IF POS[I]=N THEN WL^.ADD('XX') ELSE WL^.ADD('  ');
    END;
    IF I<7 THEN WL^.ADD(#13+'       ͹'+#13) ELSE WL^.ADD(#13);
   END;
   WL^.ADD('       ͼ'+#13);
  END;
 END;
END;
VAR FRAME:PWIN;
BEGIN
 NEW(FRAME,INIT(GROUND,0,1,24,80,TRUE,TRUE));
 NEW(WL,INIT(FRAME,0,0,24,80,'Lsungen zum 8-Damen-Problem',TRUE,TRUE,FALSE,@MAINC^.WINEDIT,FALSE,65535,255));
 WL^.DISABLE;
 NEW(TXTMSG,INIT(GROUND,0,0,80,'>8-Damen-Problem berechnen...',@MAINC^.TEXT,1));
 WL^.FOCUS;
 FILLCHAR(LIN,8,0);
 FILLCHAR(POS,8,0);
 LIN[0]:=8;
 NUM:=0;
 GNUM:=0;
 LP:=0;
 WINU.SETRUNSPEED(100);
 WINU.RUNTIMER;
 SCAN;
 AKTKEY:=0;
 REPEAT
  IF (AKTKEY=KEY_SPECIAL_RETURN) AND (LP<>65535) THEN
  BEGIN
   SCAN;
   AKTKEY:=0;
  END;
 UNTIL AKTKEY=KEY_SPECIAL_ESC;
END.