UNIT OBJ2;
INTERFACE
USES MODE3,KCCM,WINU,NUMCONV,OBJS,OBJ1;
TYPE PSTATUSBAR=^TSTATUSBAR;
     TSTATUSBAR=OBJECT(TWIN)
      PRIVATE
      POS:BYTE;
      PUBLIC
      PROCEDURE PAINT;VIRTUAL;
      FUNCTION MOUSE:BOOLEAN;VIRTUAL;
      PROCEDURE SETPOS(W:BYTE);
      CONSTRUCTOR INIT(BAS:PWIN;X,Y:INTEGER;H,B:WORD);
     END;
TYPE PSTATUSWIN=^TSTATUSWIN;
     TSTATUSWIN=OBJECT(TWINDOW)
      PRIVATE
      TXT:PTEXT;
      PST:PSTATUSBAR;
      PUBLIC
      PROCEDURE SETTEXT(S:STRING);
      PROCEDURE SETPOS(B:BYTE);
      CONSTRUCTOR INIT(BAS:PWIN;X,Y:INTEGER;B:WORD;T,TX:STRING);
     END;
TYPE PDSTATUSWIN=^TDSTATUSWIN;
     TDSTATUSWIN=OBJECT(TWINDOW)
      PRIVATE
      LTXT,GTXT:PTEXT;
      LSTB,GSTB:PSTATUSBAR;
      PUBLIC
      CONSTRUCTOR INIT(BAS:PWIN;X,Y:INTEGER;B:WORD;T,TX,TX2:STRING);
      PROCEDURE SETLPOS(B:BYTE);
      PROCEDURE SETGPOS(B:BYTE);
      PROCEDURE SETLTEXT(S:STRING);
      PROCEDURE SETGTEXT(S:STRING);
     END;
TYPE PTXTSC=^TTXTSC;
     TTXTSC=OBJECT(TWIN)
      PRIVATE
      TXT:STRING;
      AT:BYTE;
      POS:INTEGER;
      UB,UBM:BOOLEAN;
      DIR:BYTE;
      PUBLIC
      CONSTRUCTOR INIT(BAS:PWIN;X,Y:INTEGER;B:WORD;T:STRING;A:BYTE;P:BYTE;U,UM:BOOLEAN);
      PROCEDURE PAINT;VIRTUAL;
      FUNCTION MOUSE:BOOLEAN;VIRTUAL;
     END;
TYPE PCHARTAB=^TCHARTAB;
     TCHARTAB=OBJECT(TWIN)
      PROCEDURE PAINT;VIRTUAL;
      FUNCTION MOUSE:BOOLEAN;VIRTUAL;
      CONSTRUCTOR INIT(BAS:PWIN;X,Y:INTEGER);
     END;
TYPE PBINRUN=^TBINRUN;
     TBINRUN=OBJECT(TWIN)
      PRIVATE
      AR:ARRAY[0..24,0..79] OF SYSTEM.CHAR;
      RP,RS:WORD;
      PUBLIC
      FUNCTION MOUSE:BOOLEAN;VIRTUAL;
      PROCEDURE PAINT;VIRTUAL;
      CONSTRUCTOR INIT(BAS:PWIN;X,Y:INTEGER;H,B,R:WORD);
      PROCEDURE SETHBC(VAR H,B:WORD);VIRTUAL;
     END;
TYPE PWINBINRUN=^TWINBINRUN;
     TWINBINRUN=OBJECT(TWINDOW)
      PRIVATE
      BIN:PBINRUN;
      PUBLIC
      PROCEDURE CSIZE;VIRTUAL;
      CONSTRUCTOR INIT(BAS:PWIN;X,Y:INTEGER;H,B:WORD;T:STRING;DR,SZ,CL:BOOLEAN;M:WORD);
     END;
TYPE PSTARS=^TSTARS;
     TSTARS=OBJECT(TWIN)
      ST:ARRAY[1..255] OF BYTE;
      STX,STY:ARRAY[1..255] OF INTEGER;
      STC:BYTE;
      CONSTRUCTOR INIT(BAS:PWIN;X,Y:INTEGER;H,B:WORD;C:BYTE);
      PROCEDURE PAINT;VIRTUAL;
      FUNCTION MOUSE:BOOLEAN;VIRTUAL;
     END;
TYPE PWINSTARS=^TWINSTARS;
     TWINSTARS=OBJECT(TWINDOW)
      PRIVATE
      BIN:PSTARS;
      PUBLIC
      PROCEDURE CSIZE;VIRTUAL;
      CONSTRUCTOR INIT(BAS:PWIN;X,Y:INTEGER;H,B:WORD;T:STRING;DR,SZ,CL:BOOLEAN;M:WORD);
     END;
IMPLEMENTATION
VAR PCF:PCHARFILTER;
CONSTRUCTOR TDSTATUSWIN.INIT(BAS:PWIN;X,Y:INTEGER;B:WORD;T,TX,TX2:STRING);
BEGIN
 INHERITED INIT(BAS,X,Y,11,B,T,TRUE,FALSE,FALSE,@MAINC^.WINDOW);
 NEW(LTXT,INIT(@SELF,2,2,B-4,TX,@MAINC^.TEXT,0));
 NEW(LSTB,INIT(@SELF,2,4,1,B-4));
 NEW(GTXT,INIT(@SELF,2,6,B-4,TX2,@MAINC^.TEXT,0));
 NEW(GSTB,INIT(@SELF,2,8,1,B-4));
END;
PROCEDURE TDSTATUSWIN.SETLPOS(B:BYTE);
BEGIN
 LSTB^.SETPOS(B);
END;
PROCEDURE TDSTATUSWIN.SETGPOS(B:BYTE);
BEGIN
 GSTB^.SETPOS(B);
END;
PROCEDURE TDSTATUSWIN.SETLTEXT(S:STRING);
BEGIN
 LTXT^.SETTEXT(S);
END;
PROCEDURE TDSTATUSWIN.SETGTEXT(S:STRING);
BEGIN
 GTXT^.SETTEXT(S);
END;
PROCEDURE TSTATUSWIN.SETTEXT(S:STRING);
BEGIN
 TXT^.SETTEXT(S);
END;
PROCEDURE TSTATUSWIN.SETPOS(B:BYTE);
BEGIN
 PST^.SETPOS(B);
END;
CONSTRUCTOR TSTATUSWIN.INIT(BAS:PWIN;X,Y:INTEGER;B:WORD;T,TX:STRING);
BEGIN
 INHERITED INIT(BAS,X,Y,7,B,T,TRUE,FALSE,FALSE,@MAINC^.WINDOW);
 NEW(TXT,INIT(@SELF,2,2,B-4,TX,@MAINC^.TEXT,0));
 NEW(PST,INIT(@SELF,2,4,1,B-4));
END;
PROCEDURE TSTATUSBAR.SETPOS(W:BYTE);
BEGIN
 POS:=W;
END;
FUNCTION TSTATUSBAR.MOUSE:BOOLEAN;
BEGIN
 IF CIN THEN
 BEGIN
  MOUSE:=TRUE;
  IF NOT ISANYFOCUS THEN
  BEGIN
   IF (CDB AND 127>0) AND (NOT COTHER) AND (NOT CUNDER) AND (NOT ISFOCUS) THEN
   BEGIN
    FOCUS;
   END;
  END
  ELSE
  BEGIN
   IF (CDB AND 127>0) AND (NOT COTHER) AND (NOT CUNDER) AND GETTHEFOCUS^.FREEFOCUS(@SELF) AND (NOT ISFOCUS) THEN
   BEGIN
    FOCUS;
   END;
  END
 END ELSE MOUSE:=FALSE;
END;
PROCEDURE TSTATUSBAR.PAINT;
VAR S:STRING[4];
BEGIN
 CLEAR(#32,$1E);
 BAR(0,0,GETH,ROUND(POS*(GETB/100)),#32,$4F);
 S:=NUMSTR(10,POS)+'%';
 PUTSC(GETB DIV 2-(LENGTH(S) DIV 2),GETH DIV 2,S);
 IF CIN AND (NOT COTHER) THEN PUT(CDX,CDY,GETC(CDX,CDY),NOT (GETA(CDX,CDY) OR 128));
END;
CONSTRUCTOR TSTATUSBAR.INIT(BAS:PWIN;X,Y:INTEGER;H,B:WORD);
BEGIN
 INHERITED INIT(BAS,X,Y,H,B,FALSE,FALSE);
 POS:=0;
END;
FUNCTION TTXTSC.MOUSE:BOOLEAN;
BEGIN
 IF CIN AND ((NOT UBM) OR ((CDX>POS-1) AND (CDX<POS+LENGTH(TXT)))) THEN
 BEGIN
  MOUSE:=TRUE;
  IF NOT ISANYFOCUS THEN
  BEGIN
   IF (CDB AND 127>0) AND (NOT COTHER) AND (NOT CUNDER) AND (NOT ISFOCUS) THEN
   BEGIN
    FOCUS;
   END;
  END
  ELSE
  BEGIN
   IF (CDB AND 127>0) AND (NOT COTHER) AND (NOT CUNDER) AND GETTHEFOCUS^.FREEFOCUS(@SELF) AND (NOT ISFOCUS) THEN
   BEGIN
    FOCUS;
   END;
  END
 END ELSE MOUSE:=FALSE;
 IF ISANI THEN
 BEGIN
  IF DIR=0 THEN
  BEGIN
   DEC(POS);
   IF POS<-LENGTH(TXT) THEN POS:=GETB;
  END
  ELSE
  BEGIN
   INC(POS);
   IF POS>GETB THEN POS:=-LENGTH(TXT);
  END;
  MUSTDRAW;
 END;
END;
PROCEDURE TTXTSC.PAINT;
BEGIN
 IF NOT UB THEN CLEAR(' ',AT);
 PUTS(POS,0,TXT,AT);
 IF ((NOT UBM) OR ((CDX>POS-1) AND (CDX<POS+LENGTH(TXT)))) THEN
 BEGIN
  IF CIN AND (NOT COTHER) THEN PUT(CDX,CDY,GETC(CDX,CDY),NOT (GETA(CDX,CDY) OR 128));
 END;
END;
CONSTRUCTOR TTXTSC.INIT(BAS:PWIN;X,Y:INTEGER;B:WORD;T:STRING;A:BYTE;P:BYTE;U,UM:BOOLEAN);
BEGIN
 INHERITED INIT(BAS,X,Y,1,B,FALSE,FALSE);
 TXT:=T;
 AT:=A;
 IF P=0 THEN POS:=B ELSE POS:=-LENGTH(T);
 UB:=U;
 UBM:=UM;
 DIR:=P;
END;
CONSTRUCTOR TCHARTAB.INIT(BAS:PWIN;X,Y:INTEGER);
BEGIN
 INHERITED INIT(BAS,X,Y,16,16,FALSE,FALSE);
END;
FUNCTION TCHARTAB.MOUSE:BOOLEAN;
BEGIN
 IF CIN THEN
 BEGIN
  MOUSE:=TRUE;
  IF NOT ISANYFOCUS THEN
  BEGIN
   IF (CDB AND 127>0) AND (NOT COTHER) AND (NOT CUNDER) AND (NOT ISFOCUS) THEN
   BEGIN
    FOCUS;
   END;
  END
  ELSE
  BEGIN
   IF (CDB AND 127>0) AND (NOT COTHER) AND (NOT CUNDER) AND GETTHEFOCUS^.FREEFOCUS(@SELF) AND (NOT ISFOCUS) THEN
   BEGIN
    FOCUS;
   END;
  END;
 END ELSE MOUSE:=FALSE;
END;
PROCEDURE TCHARTAB.PAINT;
VAR I,N:BYTE;
BEGIN
 FOR I:=0 TO 15 DO
 BEGIN
  FOR N:=0 TO 15 DO
  BEGIN
   PUT(N,I,SYSTEM.CHAR(I*16+N),$1E);
  END;
 END;
 IF CIN AND (NOT COTHER) THEN PUT(CDX,CDY,GETC(CDX,CDY),NOT (GETA(CDX,CDY) OR 128));
END;
PROCEDURE TWINBINRUN.CSIZE;
BEGIN
 INHERITED CSIZE;
 BIN^.SETHB(GETH-2,GETB-2);
END;
CONSTRUCTOR TWINBINRUN.INIT(BAS:PWIN;X,Y:INTEGER;H,B:WORD;T:STRING;DR,SZ,CL:BOOLEAN;M:WORD);
BEGIN
 INHERITED INIT(BAS,X,Y,H,B,T,DR,SZ,CL,@MAINC^.WINDOW);
 NEW(BIN,INIT(@SELF,1,1,H-2,B-2,M));
END;
PROCEDURE TBINRUN.SETHBC(VAR H,B:WORD);
BEGIN
 IF INTEGER(H)<1 THEN H:=1;
 IF INTEGER(B)<1 THEN B:=1;
END;
FUNCTION TBINRUN.MOUSE:BOOLEAN;
VAR I,N:BYTE;
    P:POINTER;
BEGIN
 IF CIN THEN
 BEGIN
  MOUSE:=TRUE;
  IF NOT ISANYFOCUS THEN
  BEGIN
   IF (CDB AND 127>0) AND (NOT COTHER) AND (NOT CUNDER) AND (NOT ISFOCUS) THEN
   BEGIN
    FOCUS;
   END;
  END
  ELSE
  BEGIN
   IF (CDB AND 127>0) AND (NOT COTHER) AND (NOT CUNDER) AND GETTHEFOCUS^.FREEFOCUS(@SELF) AND (NOT ISFOCUS) THEN
   BEGIN
    FOCUS;
   END;
  END;
 END ELSE MOUSE:=FALSE;
 IF ISANI THEN
 BEGIN
  IF RP=0 THEN
  BEGIN
   RP:=RS;
   P:=@AR;
   ASM
     CLI
     PUSH DS
     LES DI,P
     LDS SI,P
     ADD SI,80
     MOV CX,80*6
     REP
     DB 66h;MOVSW
     POP DS
     STI
   END;
   FOR I:=0 TO 79 DO IF RANDOM(2)=0 THEN AR[24,I]:='0' ELSE AR[24,I]:='1';
   MUSTDRAW;
  END ELSE DEC(RP);
 END;
END;
PROCEDURE TBINRUN.PAINT;
VAR I,N:BYTE;
BEGIN
 FOR I:=0 TO GETB-1 DO
 BEGIN
  FOR N:=0 TO GETH-1 DO
  BEGIN
   MODE3.PUT(I,N,AR[N,I],$02);
  END;
 END;
 IF CIN AND (NOT COTHER) THEN MODE3.PUT(CDX,CDY,GETC(CDX,CDY),NOT (GETA(CDX,CDY) OR 128));
END;
CONSTRUCTOR TBINRUN.INIT(BAS:PWIN;X,Y:INTEGER;H,B,R:WORD);
VAR I,N:BYTE;
BEGIN
 INHERITED INIT(BAS,X,Y,H,B,FALSE,FALSE);
 RS:=R;
 RP:=R;
 FOR I:=0 TO 79 DO
 BEGIN
  FOR N:=0 TO 24 DO
  BEGIN
   IF RANDOM(2)=0 THEN AR[N,I]:='0' ELSE AR[N,I]:='1';
  END;
 END;
END;
PROCEDURE TWINSTARS.CSIZE;
BEGIN
 INHERITED CSIZE;
 BIN^.SETHB(GETH-2,GETB-2);
END;
CONSTRUCTOR TWINSTARS.INIT(BAS:PWIN;X,Y:INTEGER;H,B:WORD;T:STRING;DR,SZ,CL:BOOLEAN;M:WORD);
BEGIN
 INHERITED INIT(BAS,X,Y,H,B,T,DR,SZ,CL,@MAINC^.WINDOW);
 NEW(BIN,INIT(@SELF,1,1,H-2,B-2,M));
END;
FUNCTION TSTARS.MOUSE:BOOLEAN;
VAR I:BYTE;
BEGIN
 IF CIN THEN
 BEGIN
  MOUSE:=TRUE;
  IF NOT ISANYFOCUS THEN
  BEGIN
   IF (CDB AND 127>0) AND (NOT COTHER) AND (NOT CUNDER) AND (NOT ISFOCUS) THEN
   BEGIN
    FOCUS;
   END;
  END
  ELSE
  BEGIN
   IF (CDB AND 127>0) AND (NOT COTHER) AND (NOT CUNDER) AND GETTHEFOCUS^.FREEFOCUS(@SELF) AND (NOT ISFOCUS) THEN
   BEGIN
    FOCUS;
   END;
  END;
 END ELSE MOUSE:=FALSE;
 IF ISANI THEN
 BEGIN
  FOR I:=1 TO STC DO
  BEGIN
   IF ST[I]=0 THEN
   BEGIN
    IF RANDOM(100)=0 THEN
    BEGIN
     STX[I]:=RANDOM(80);
     STY[I]:=RANDOM(25);
     INC(ST[I]);
    END;
   END
   ELSE
   BEGIN
    INC(ST[I]);
    IF ST[I]=127 THEN ST[I]:=0;
   END;
  END;
  MUSTDRAW;
 END;
END;
PROCEDURE TSTARS.PAINT;
VAR I:BYTE;
BEGIN
 MODE3.CLEAR(' ',0);
 FOR I:=1 TO STC DO
 BEGIN
  CASE ST[I] OF
   1..9:MODE3.PUT(STX[I],STY[I],#249,14);
   10..19:MODE3.PUT(STX[I],STY[I],#7,14);
   20..105:MODE3.PUT(STX[I],STY[I],'*',14);
   106..115:MODE3.PUT(STX[I],STY[I],#7,14);
   116..126:MODE3.PUT(STX[I],STY[I],#249,14);
  END;
 END;
 IF CIN AND (NOT COTHER) THEN PUT(CDX,CDY,GETC(CDX,CDY),NOT (GETA(CDX,CDY) OR 128));
END;
CONSTRUCTOR TSTARS.INIT(BAS:PWIN;X,Y:INTEGER;H,B:WORD;C:BYTE);
BEGIN
 INHERITED INIT(BAS,X,Y,H,B,FALSE,FALSE);
 STC:=C;
 FILLCHAR(ST,256,0);
END;
BEGIN
 NEW(PCF);
 PCF^.FILL(0,255,0);
 PCF^.FILL(60,10,1);
END.