UNIT WINU;
INTERFACE
TYPE PWIN=^TWIN;
     TWIN=OBJECT
      PRIVATE
      X,Y:INTEGER;
      H,B:WORD;
      NEXT,LAST,UNDER,OVER,UNDERL:PWIN;
      SEL,FOC,VISIBLE:BOOLEAN;
      PROCEDURE SELECT(W:PWIN);
      PROCEDURE UNSELECT;
      PROCEDURE PAINTH;
      FUNCTION MOUSEH(I:BOOLEAN):BOOLEAN;
      PROCEDURE KEYH(K:LONGINT);
      PROCEDURE CSIZEH;
      PROCEDURE CPOSH;
      PROCEDURE DONEU(P:PWIN);
      PROCEDURE INITU(P:PWIN);
      PUBLIC
      CUNDER,COTHER,CIN:BOOLEAN;
      CDX,CDY,CDB:INTEGER;
      CONSTRUCTOR INIT(BAS:PWIN;PX,PY:INTEGER;PH,PB:WORD;INPF,WINF:BOOLEAN);
      DESTRUCTOR DONE;
      PROCEDURE PAINT;VIRTUAL;
      PROCEDURE KEY(K:LONGINT);VIRTUAL;
      FUNCTION MOUSE:BOOLEAN;VIRTUAL;
      PROCEDURE FOCUS;
      PROCEDURE UNFOCUS;
      FUNCTION FREEFOCUS(P:PWIN):BOOLEAN;VIRTUAL;
      PROCEDURE SETXYC(VAR SX,SY:INTEGER);VIRTUAL;
      PROCEDURE SETXY(SX,SY:INTEGER);
      PROCEDURE SETHBC(VAR SH,SB:WORD);VIRTUAL;
      PROCEDURE SETHB(SH,SB:WORD);
      FUNCTION GETH:WORD;
      FUNCTION GETB:WORD;
      FUNCTION GETX:INTEGER;
      FUNCTION GETY:INTEGER;
      FUNCTION ISFOCUS:BOOLEAN;
      FUNCTION ISSELECT:BOOLEAN;
      PROCEDURE CSIZE;VIRTUAL;
      PROCEDURE CPOS;VIRTUAL;
      PROCEDURE DRAG;
      PROCEDURE SIZE;
      FUNCTION GETOVERH:WORD;
      FUNCTION GETOVERB:WORD;
      PROCEDURE BRINGTOFRONT;
      FUNCTION ONTOP:BOOLEAN;
      FUNCTION ONSELECT(W:PWIN):PWIN;VIRTUAL;
      FUNCTION ISVISIBLE:BOOLEAN;
      FUNCTION REALYVIS:BOOLEAN;
      PROCEDURE HIDE;
      PROCEDURE SHOW;
      FUNCTION GETOVER:PWIN;
      FUNCTION GETNEXT:PWIN;
      FUNCTION GETLAST:PWIN;
      FUNCTION GETUNDER:PWIN;
      PROCEDURE ONFOCUS;VIRTUAL;
      PROCEDURE ONDONE(P:PWIN);VIRTUAL;
      PROCEDURE ONUNSELECT;VIRTUAL;
      PROCEDURE ONUNFOCUS;VIRTUAL;
      PROCEDURE ONINIT(P:PWIN);VIRTUAL;
      PROCEDURE HIDESUB;
      PROCEDURE SHOWSUB;
      PROCEDURE ONHIDE;VIRTUAL;
      PROCEDURE ONSHOW;VIRTUAL;
      FUNCTION GETSUB(I:WORD):PWIN;
      FUNCTION GETSUBMAX:WORD;
      PROCEDURE SETOVER(P:PWIN);
     END;
FUNCTION ISANYFOCUS:BOOLEAN;
FUNCTION GETTHEFOCUS:PWIN;
PROCEDURE RUNENGINE;
PROCEDURE SETBACK(P:PWIN);
FUNCTION GETLASTB:WORD;
FUNCTION GETLASTX:INTEGER;
FUNCTION GETLASTY:INTEGER;
PROCEDURE INIT;
PROCEDURE DONE;
FUNCTION IST:BOOLEAN;
FUNCTiON ISCUR:BOOLEAN;
PROCEDURE MUSTDRAW;
PROCEDURE SETTSPEED(W:WORD);
PROCEDURE SETCURSPEED(W:WORD);
PROCEDURE SIMPLEDRAW;
PROCEDURE RUNTIMER;
PROCEDURE STOPTIMER;
PROCEDURE SETRUNSPEED(P:WORD);
PROCEDURE SETINET;
PROCEDURE CLEARINET;
PROCEDURE SETANISPEED(W:WORD);
FUNCTION ISANI:BOOLEAN;
FUNCTION GETANIP:WORD;
FUNCTION GETTP:WORD;
FUNCTION GETCURP:WORD;
FUNCTION GETINET:WORD;
PROCEDURE RESET;
FUNCTION ISRUN:BOOLEAN;
IMPLEMENTATION
USES MODE3,MOUSE,KEYB;
VAR AFOC,BACK,DRAGOBJ,SIZEOBJ:PWIN;
    SMSX,SMSY,SMSB,LASTX,LASTY,LASTB,DRAGADDX,DRAGADDY,DRAGX,DRAGY:INTEGER;
    DRAW,T,TSET,CURON,RUNET,ANI,ASET,ISINST,ISEXIT,RUNSET:BOOLEAN;
    SIZEH,SIZEB,TS,TP,CURS,CURP,RUNS,RUNP,INET,ANIS,ANIP:WORD;
    OLDINT8,EXITOLD:POINTER;
    NMSC:SYSTEM.CHAR;
    NMSA:BYTE;
FUNCTION ISRUN:BOOLEAN;ASSEMBLER;
ASM
  MOV AL,RUNET
END;
FUNCTION TWIN.GETSUBMAX:WORD;
VAR P:PWIN;
    C:WORD;
BEGIN
 C:=0;
 P:=UNDER;
 WHILE P^.NEXT<>NIL DO
 BEGIN
  INC(C);
  P:=P^.NEXT;
 END;
 GETSUBMAX:=C;
END;
FUNCTION TWIN.GETSUB(I:WORD):PWIN;
VAR P:PWIN;
    N:WORD;
BEGIN
 P:=UNDER;
 FOR N:=1 TO I DO P:=P^.NEXT;
 GETSUB:=P;
END;
FUNCTION TWIN.REALYVIS:BOOLEAN;
VAR P:PWIN;
BEGIN
 P:=@SELF;
 WHILE P<>NIL DO
 BEGIN
  IF NOT P^.VISIBLE THEN
  BEGIN
   REALYVIS:=FALSE;
   EXIT;
  END;
  P:=P^.OVER;
 END;
 REALYVIS:=TRUE;
END;
PROCEDURE TWIN.ONHIDE;
BEGIN
END;
PROCEDURE TWIN.ONSHOW;
BEGIN
END;
PROCEDURE TWIN.SHOWSUB;
VAR P:PWIN;
BEGIN
 INC(INET);
 P:=UNDER;
 WHILE P<>NIL DO
 BEGIN
  IF NOT P^.VISIBLE THEN
  BEGIN
   P^.VISIBLE:=TRUE;
   P^.ONSHOW;
  END;
  P:=P^.NEXT;
 END;
 DEC(INET);
END;
PROCEDURE TWIN.HIDESUB;
VAR P:PWIN;
BEGIN
 INC(INET);
 P:=UNDER;
 WHILE P<>NIL DO
 BEGIN
  IF P^.VISIBLE THEN
  BEGIN
   P^.VISIBLE:=FALSE;
   P^.ONHIDE;
  END;
  P:=P^.NEXT;
 END;
 DEC(INET);
END;
FUNCTION GETINET:WORD;ASSEMBLER;
ASM
  MOV AX,INET
END;
FUNCTION GETCURP:WORD;ASSEMBLER;
ASM
  MOV AX,CURP
END;
FUNCTION GETTP:WORD;ASSEMBLER;
ASM
  MOV AX,TP
END;
FUNCTION GETANIP:WORD;ASSEMBLER;
ASM
  MOV AX,ANIP
END;
FUNCTION ISANI:BOOLEAN;ASSEMBLER;
ASM
  MOV AL,ANI
END;
PROCEDURE SETANISPEED(W:WORD);ASSEMBLER;
ASM
  MOV AX,W
  MOV ANIS,AX
END;
PROCEDURE SETINET;ASSEMBLER;
ASM
  INC INET
END;
PROCEDURE CLEARINET;ASSEMBLER;
ASM
  DEC INET
END;
PROCEDURE SETRUNSPEED(P:WORD);ASSEMBLER;
ASM
  MOV AX,P
  MOV RUNS,AX
END;
PROCEDURE RUNTIMER;ASSEMBLER;
ASM
  MOV RUNET,1
END;
PROCEDURE STOPTIMER;ASSEMBLER;
ASM
  MOV RUNET,0
END;
PROCEDURE SIMPLEDRAW;ASSEMBLER;
ASM
  LES DI,BACK
  PUSH ES
  PUSH DI
  PUSH 1
  PUSH ES
  PUSH DI
  CALL TWIN.MOUSEH
  CALL TWIN.PAINTH
  CALL MODE3.SHOW
END;
FUNCTION ISCUR:BOOLEAN;ASSEMBLER;
ASM
  MOV AL,CURON
END;
PROCEDURE SETCURSPEED(W:WORD);ASSEMBLER;
ASM
  MOV AX,W
  MOV CURS,AX
END;
PROCEDURE SETTSPEED(W:WORD);ASSEMBLER;
ASM
  MOV AX,W
  MOV TS,AX
END;
PROCEDURE MUSTDRAW;ASSEMBLER;
ASM
  MOV DRAW,TRUE
END;
PROCEDURE WIN_EXIT;FAR;
BEGIN
 DONE;
 EXITPROC:=EXITOLD;
END;
FUNCTION TWIN.GETNEXT:PWIN;ASSEMBLER;
ASM
  LES DI,[BP+6]
  MOV AX,WORD PTR ES:[DI+NEXT]
  MOV DX,WORD PTR ES:[DI+NEXT+2]
END;
FUNCTION TWIN.GETLAST:PWIN;ASSEMBLER;
ASM
  LES DI,[BP+6]
  MOV AX,WORD PTR ES:[DI+LAST]
  MOV DX,WORD PTR ES:[DI+LAST+2]
END;
FUNCTION TWIN.GETUNDER:PWIN;ASSEMBLER;
ASM
  LES DI,[BP+6]
  MOV AX,WORD PTR ES:[DI+UNDER]
  MOV DX,WORD PTR ES:[DI+UNDER+2]
END;
PROCEDURE TWIN.ONUNFOCUS;ASSEMBLER;
ASM
  MOV DRAW,TRUE
END;
PROCEDURE TWIN.ONUNSELECT;ASSEMBLER;
ASM
  MOV DRAW,TRUE
END;
PROCEDURE TWIN.ONINIT(P:PWIN);ASSEMBLER;
ASM
END;
PROCEDURE TWIN.ONDONE(P:PWIN);ASSEMBLER;
ASM
END;
PROCEDURE TWIN.INITU(P:PWIN);
BEGIN
 ONINIT(P);
 IF OVER<>NIL THEN OVER^.INITU(P);
END;
PROCEDURE TWIN.DONEU(P:PWIN);
BEGIN
 ONDONE(P);
 IF OVER<>NIL THEN OVER^.DONEU(P);
END;
PROCEDURE TWIN.ONFOCUS;ASSEMBLER;
ASM
  MOV DRAW,TRUE
END;
FUNCTION GETLASTX:INTEGER;ASSEMBLER;
ASM
  MOV AX,LASTX
END;
FUNCTION GETLASTY:INTEGER;ASSEMBLER;
ASM
  MOV AX,LASTY
END;
FUNCTION TWIN.GETOVER:PWIN;ASSEMBLER;
ASM
  LES DI,[BP+6]
  MOV AX,WORD PTR ES:[DI+OVER]
  MOV DX,WORD PTR ES:[DI+OVER+2]
END;
FUNCTION IST:BOOLEAN;ASSEMBLER;
ASM
  MOV AL,T
END;
PROCEDURE INT8;INTERRUPT;ASSEMBLER;
ASM
  DB 66h;PUSHA
  CLD
  MOV AX,ANIP
  DEC AX
  JS @SETA
  MOV ANIP,AX
  JMP @EXTA
 @SETA:
  MOV AX,ANIS
  MOV ANIP,AX
  MOV ASET,TRUE
 @EXTA:
  MOV AX,TP
  DEC AX
  JS @SETT
  MOV TP,AX
  JMP @EXTT
 @SETT:
  MOV AX,TS
  MOV TP,AX
  MOV TSET,TRUE
 @EXTT:
  MOV AX,CURP
  DEC AX
  JS @SETCUR
  MOV CURP,AX
  JMP @EXTCUR
 @SETCUR:
  MOV AX,CURS
  MOV CURP,AX
  MOV AL,CURON
  NOT AL
  AND AL,1
  MOV CURON,AL
  MOV DRAW,TRUE
 @EXTCUR:
  MOV AX,RUNP
  DEC AX
  JS @DRUNET
  MOV RUNP,AX
  JMP @ENDTIM
 @DRUNET:
  MOV RUNSET,TRUE
  MOV AX,RUNS
  MOV RUNP,AX
 @ENDTIM:
  MOV AL,20h
  OUT 20h,AL
  MOV AX,INET
  OR AX,AX
  JNZ @EXT
  MOV AL,RUNSET
  OR AL,AL
  JZ @EXT
  MOV AL,RUNET
  OR AL,AL
  JZ @EXT
  CALL RUNENGINE
  MOV RUNSET,FALSE
 @EXT:
  DB 66h;POPF
END;
PROCEDURE TWIN.SHOW;
BEGIN
 IF NOT VISIBLE THEN
 BEGIN
  VISIBLE:=TRUE;
  ONSHOW;
 END;
END;
PROCEDURE TWIN.HIDE;
BEGIN
 IF VISIBLE THEN
 BEGIN
  VISIBLE:=FALSE;
  ONHIDE;
 END;
END;
FUNCTION TWIN.ISVISIBLE;ASSEMBLER;
ASM
  LES DI,[BP+6]
  MOV AL,ES:[DI+VISIBLE]
END;
FUNCTION TWIN.ONSELECT(W:PWIN):PWIN;ASSEMBLER;
ASM
  LES DI,[BP+6]
  PUSH ES
  PUSH DI
  CALL TWIN.MUSTDRAW
  MOV AX,WORD PTR W
  MOV DX,WORD PTR W+2
END;
FUNCTION TWIN.ONTOP:BOOLEAN;ASSEMBLER;
ASM
  LES DI,[BP+6]
  DB 026h,066h,08Bh,045h,NEXT
  DB 066h;OR AX,AX
  DB 00Fh,094h,0C0h
END;
PROCEDURE DONE;
BEGIN
 IF NOT ISINST THEN
 BEGIN
  EXIT;
 END;
 ASM
   INC INET
   XOR AX,AX
   MOV ISINST,AL
   MOV ES,AX
   MOV DI,8*4
   DB 66h;MOV AX,WORD PTR OLDINT8
   DB 66h;MOV ES:[DI],AX
   MOV AL,36h
   OUT 43h,AL
   XOR AX,AX
   OUT 40h,AL
   OUT 40h,AL
   DEC INET
  @EXT:
 END;
END;
FUNCTION HPERR(SZ:WORD):INTEGER;FAR;ASSEMBLER;
ASM
  MOV AX,1
END;
PROCEDURE RESET;ASSEMBLER;
ASM
  MOV AL,ISINST
  OR AL,AL
  JZ @EXT
  INC INET
  MOV CURS,1000
  MOV TS,100
  MOV RUNS,50
  MOV ANIS,50
  XOR AX,AX
  PUSH AX
  PUSH AX
  PUSH AX
  CALL MODE3.SETCURSOR
  MOV AL,43h
  OUT 43,AL
  XOR AX,AX
  OUT 40h,AL
  MOV AL,1
  OUT 40h,AL
  MOV AX,MSX
  MOV LASTX,AX
  MOV SMSX,AX
  MOV AX,MSY
  MOV SMSY,AX
  MOV LASTY,AX
  MOV AX,MSB
  MOV SMSB,AX
  MOV LASTB,AX
  MOV DRAW,TRUE
  DEC INET
 @EXT:
END;
PROCEDURE INIT;
BEGIN
 INC(INET);
 IF NOT ISEXIT THEN
 BEGIN
  HEAPERROR:=@HPERR;
  EXITOLD:=EXITPROC;
  EXITPROC:=@WIN_EXIT;
 END;
 CURS:=1000;
 TS:=100;
 RUNS:=50;
 ANIS:=50;
 SETCURSOR(FALSE,0,0);
 ASM
   MOV AL,43h
   OUT 43,AL
   XOR AX,AX
   OUT 40h,AL
   MOV AL,1
   OUT 40h,AL
   MOV ISINST,TRUE
   MOV AX,MSX
   MOV LASTX,AX
   MOV SMSX,AX
   MOV AX,MSY
   MOV SMSY,AX
   MOV LASTY,AX
   MOV AX,MSB
   MOV SMSB,AX
   MOV LASTB,AX
   DB 66h;XOR AX,AX
   MOV TS,AX
   DB 66h;MOV WORD PTR SIZEOBJ,AX
   DB 66h;MOV WORD PTR DRAGOBJ,AX
   MOV DRAW,TRUE
   MOV ES,AX
   MOV DI,8*4
   DB 026h,066h,08Bh,005h
   DB 066h;MOV WORD PTR OLDINT8,AX
   MOV AX,OFFSET INT8
   STOSW
   MOV AX,SEG INT8
   STOSW
   DEC INET
 END;
END;
PROCEDURE TWIN.BRINGTOFRONT;ASSEMBLER;
ASM
  INC INET
  PUSH DS
  LES DI,[BP+6]
  LDS SI,ES:[DI+OVER]
  DB 066h,08Bh,05Eh,6
  DB 03Eh,066h,03Bh,05Ch,UNDERL
  JZ @EXT
  LDS SI,ES:[DI+NEXT]
  DB 026h,066h,08Bh,045h,LAST
  DB 03Eh,066h,089h,044h,LAST
  DB 66h;OR AX,AX
  JZ @SETOVER_UNDER
  LDS SI,ES:[DI+LAST]
  DB 026h,066h,08Bh,045h,NEXT
  DB 03Eh,066h,089h,044h,NEXT
  LDS SI,ES:[DI+OVER]
  JMP @SETLAST_NEXT
 @SETOVER_UNDER:
  LDS SI,ES:[DI+OVER]
  DB 026h,066h,08Bh,045h,NEXT
  DB 03Eh,066h,089h,044h,UNDER
 @SETLAST_NEXT:
  DB 03Eh,066h,08Bh,044h,UNDERL
  DB 026h,066h,089h,045h,LAST
  DB 03Eh,066h,089h,05Ch,UNDERL
  LDS SI,ES:[DI+LAST]
  DB 03Eh,066h,089h,05Ch,NEXT
  DB 066h;XOR AX,AX
  DB 026h,066h,089h,045h,NEXT
 @EXT:
  POP DS
  DEC INET
END;
FUNCTION GETLASTB:WORD;ASSEMBLER;
ASM
  MOV AX,LASTB
END;
FUNCTION TWIN.GETOVERH:WORD;ASSEMBLER;
ASM
  LES DI,[BP+6]
  LES DI,ES:[DI+OVER]
  MOV AX,ES:[DI+H]
END;
FUNCTION TWIN.GETOVERB:WORD;ASSEMBLER;
ASM
  LES DI,[BP+6]
  LES DI,ES:[DI+OVER]
  MOV AX,ES:[DI+B]
END;
PROCEDURE TWIN.SIZE;ASSEMBLER;
ASM
  INC INET
  DB 66h;MOV AX,WORD PTR DRAGOBJ
  DB 66h;OR AX,AX
  JNZ @EXT
  DB 66h;MOV AX,WORD PTR SIZEOBJ
  DB 66h;OR AX,AX
  JNZ @EXT
  LES DI,[BP+6]
  MOV WORD PTR SIZEOBJ,DI
  MOV WORD PTR SIZEOBJ+2,ES
  MOV AX,ES:[DI+H]
  MOV SIZEH,AX
  MOV AX,ES:[DI+B]
  MOV SIZEB,AX
  MOV AX,SMSX
  MOV DRAGADDX,AX
  MOV AX,SMSY
  MOV DRAGADDY,AX
 @EXT:
  DEC INET
END;
PROCEDURE TWIN.DRAG;ASSEMBLER;
ASM
  INC INET
  DB 66h;MOV AX,WORD PTR DRAGOBJ
  DB 66h;OR AX,AX
  JNZ @EXT
  DB 66h;MOV AX,WORD PTR SIZEOBJ
  DB 66h;OR AX,AX
  JNZ @EXT
  LES DI,[BP+6]
  MOV WORD PTR DRAGOBJ,DI
  MOV WORD PTR DRAGOBJ+2,ES
  MOV AX,ES:[DI+X]
  MOV DRAGX,AX
  MOV AX,ES:[DI+Y]
  MOV DRAGY,AX
  MOV AX,SMSX
  MOV DRAGADDX,AX
  MOV AX,SMSY
  MOV DRAGADDY,AX
 @EXT:
  DEC INET
END;
PROCEDURE TWIN.CPOSH;
VAR P:PWIN;
BEGIN
 CPOS;
 ASM
   LES DI,[BP+6]
   DB 026h,066h,08Bh,045h,UNDER
   DB 066h;OR AX,AX
   JZ @ENDLOOP
  @NEXTLOOP:
   DB 066h;MOV WORD PTR P,AX
   DB 066h;PUSH AX
   CALL TWIN.CPOSH
   LES DI,P
   DB 026h,066h,08Bh,045h,NEXT
   DB 066h;OR AX,AX
   JNZ @NEXTLOOP
  @ENDLOOP:
 END;
END;
PROCEDURE TWIN.CSIZEH;
VAR P:PWIN;
BEGIN
 CSIZE;
 ASM
   LES DI,[BP+6]
   DB 026h,066h,08Bh,045h,UNDER
   DB 066h;OR AX,AX
   JZ @ENDLOOP
  @NEXTLOOP:
   DB 066h;MOV WORD PTR P,AX
   DB 066h;PUSH AX
   CALL TWIN.CSIZEH
   LES DI,P
   DB 026h,066h,08Bh,045h,NEXT
   DB 066h;OR AX,AX
   JNZ @NEXTLOOP
  @ENDLOOP:
 END;
END;
PROCEDURE TWIN.CSIZE;ASSEMBLER;
ASM
END;
PROCEDURE TWIN.CPOS;ASSEMBLER;
ASM
END;
PROCEDURE TWIN.SETHBC(VAR SH,SB:WORD);
BEGIN
END;
PROCEDURE TWIN.SETHB(SH,SB:WORD);
BEGIN
 INC(INET);
 SETHBC(SH,SB);
 ASM
   LES DI,[BP+6]
   MOV AX,SH
   MOV ES:[DI+H],AX
   MOV AX,SB
   MOV ES:[DI+B],AX
   PUSH ES
   PUSH DI
   CALL TWIN.CSIZEH
   MOV DRAW,TRUE
   DEC INET
 END;
END;
PROCEDURE TWIN.SETXY(SX,SY:INTEGER);
BEGIN
 INC(INET);
 SETXYC(SX,SY);
 ASM
   LES DI,[BP+6]
   MOV AX,SX
   MOV ES:[DI+X],AX
   MOV AX,SY
   MOV ES:[DI+Y],AX
   PUSH ES
   PUSH DI
   CALL TWIN.CPOSH
   MOV DRAW,TRUE
   DEC INET
 END;
END;
PROCEDURE TWIN.SETXYC(VAR SX,SY:INTEGER);
BEGIN
END;
FUNCTION TWIN.GETX:INTEGER;ASSEMBLER;
ASM
  LES DI,[BP+6]
  MOV AX,ES:[DI+X]
END;
FUNCTION TWIN.GETY:INTEGER;ASSEMBLER;
ASM
  LES DI,[BP+6]
  MOV AX,ES:[DI+Y]
END;
FUNCTION TWIN.ISSELECT:BOOLEAN;ASSEMBLER;
ASM
  LES DI,[BP+6]
  MOV AL,ES:[DI+SEL]
END;
FUNCTION TWIN.ISFOCUS:BOOLEAN;ASSEMBLER;
ASM
  LES DI,[BP+6]
  MOV AL,ES:[DI+FOC]
END;
FUNCTION TWIN.GETH:WORD;ASSEMBLER;
ASM
  LES DI,[BP+6]
  MOV AX,ES:[DI+H]
END;
FUNCTION TWIN.GETB:WORD;ASSEMBLER;
ASM
  LES DI,[BP+6]
  MOV AX,ES:[DI+B]
END;
PROCEDURE SETBACK(P:PWIN);ASSEMBLER;
ASM
  INC INET
  DB 66h;MOV AX,WORD PTR P
  DB 66h;MOV WORD PTR BACK,AX
  DEC INET
END;
PROCEDURE RUNENGINE;
BEGIN
 IF NOT RUNSET THEN EXIT;
 IF INET>0 THEN EXIT;
 INC(INET);
 IF TSET THEN
 BEGIN
  T:=TRUE;
  TSET:=FALSE;
 END;
 IF ASET THEN
 BEGIN
  ANI:=TRUE;
  ASET:=FALSE;
 END;
 IF BACK=NIL THEN
 BEGIN
  FILL(#32,0);
  PUT(MSX,MSY,'?',MSB+1);
  SHOW;
  KEYB.GET;
  EXIT;
 END;
 IF KEYB.GET THEN
 BEGIN
  BACK^.KEYH(AKTKEY);
  WHILE KEYB.GET DO BACK^.KEYH(AKTKEY);
  DRAW:=TRUE;
 END
 ELSE
 BEGIN
  IF MOUSE.ISMSC THEN
  BEGIN
   MOUSE.ISMSC:=FALSE;
   SMSX:=MSX;
   SMSY:=MSY;
   SMSB:=MSB;
   IF SIZEOBJ<>NIL THEN
   BEGIN
    SIZEOBJ^.SETHB(SMSY-DRAGADDY+SIZEH,SMSX-DRAGADDX+SIZEB);
    IF SMSB=0 THEN
    BEGIN
     SIZEOBJ:=NIL;
    END;
    INC(SMSB,128);
   END ELSE
   IF DRAGOBJ<>NIL THEN
   BEGIN
    DRAGOBJ^.SETXY(SMSX-DRAGADDX+DRAGX,SMSY-DRAGADDY+DRAGY);
    IF SMSB=0 THEN
    BEGIN
     DRAGOBJ:=NIL;
    END;
    INC(SMSB,128);
   END;
   DRAW:=TRUE;
  END;
 END;
 BACK^.MOUSEH(FALSE);
 T:=FALSE;
 ANI:=FALSE;
 IF DRAW THEN
 BEGIN
  DRAW:=FALSE;
  BACK^.PAINTH;
  SHOW;
 END;
 LASTB:=SMSB;
 LASTX:=SMSX;
 LASTY:=SMSY;
 DEC(INET);
END;
FUNCTION TWIN.FREEFOCUS(P:PWIN):BOOLEAN;ASSEMBLER;
ASM
  MOV AX,LASTB
  OR AX,AX
  JZ @OK
  CMP AX,128
  JZ @OK
  XOR AX,AX
  JMP @EXT
 @OK:
  MOV AL,1
 @EXT:
END;
FUNCTION GETTHEFOCUS:PWIN;ASSEMBLER;
ASM
  MOV AX,WORD PTR AFOC
  MOV DX,WORD PTR AFOC+2
END;
FUNCTION ISANYFOCUS:BOOLEAN;ASSEMBLER;
ASM
  DB 066h;MOV AX,WORD PTR AFOC
  DB 066h;OR AX,AX
  DB 00Fh,095h,0C0h
END;
PROCEDURE TWIN.UNFOCUS;
BEGIN
 INC(INET);
 ASM
   DB 66h;XOR AX,AX
   DB 66h;MOV WORD PTR AFOC,AX
   LES DI,[BP+6]
   MOV ES:[DI+FOC],AL
   MOV ES:[DI+SEL],AL
 END;
 ONUNFOCUS;
 ONUNSELECT;
 ASM
   LES DI,[BP+6]
   MOV ES:[DI+SEL],FALSE
   DB 26h,66h,8Bh,45h,OVER
   DB 66h;OR AX,AX
   JZ @EXT
   DB 66h;PUSH AX
   CALL TWIN.UNSELECT
  @EXT:
   DEC INET
 END;
END;
PROCEDURE TWIN.UNSELECT;
BEGIN
 ONUNSELECT;
 ASM
   LES DI,[BP+6]
   MOV ES:[DI+SEL],FALSE
   DB 26h,66h,8Bh,45h,OVER
   DB 66h;OR AX,AX
   JZ @EXT
   DB 66h;PUSH AX
   CALL TWIN.UNSELECT
  @EXT:
 END;
END;
PROCEDURE TWIN.SELECT(W:PWIN);
BEGIN
 W:=ONSELECT(W);
 ASM
   LES DI,[BP+6]
   MOV ES:[DI+SEL],TRUE
   DB 026h,066h,08Bh,045h,OVER
   DB 066h;OR AX,AX
   JZ @NO_OVER
   DB 66h;MOV BX,WORD PTR W
   DB 66h;PUSH BX
   DB 66h;PUSH AX
   CALL TWIN.SELECT
  @NO_OVER:
 END;
END;
PROCEDURE TWIN.FOCUS;
BEGIN
 ASM
   INC INET
   DB 66h;MOV AX,WORD PTR AFOC
   DB 66h;OR AX,AX
   JZ @NOFOC
   DB 66h;PUSH AX
   CALL TWIN.UNFOCUS
  @NOFOC:
 END;
 ONFOCUS;
 ASM
   LES DI,[BP+6]
   MOV WORD PTR AFOC,DI
   MOV WORD PTR AFOC+2,ES
   MOV ES:[DI+SEL],TRUE
   MOV ES:[DI+FOC],TRUE
   DB 026h,066h,08Bh,045h,OVER
   DB 066h;OR AX,AX
   JZ @NO_OVER
   PUSH ES
   PUSH DI
   DB 66h;PUSH AX
   CALL TWIN.SELECT
  @NO_OVER:
   DEC INET
 END;
END;
FUNCTION TWIN.MOUSEH(I:BOOLEAN):BOOLEAN;
VAR P:PWIN;
    R:BOOLEAN;
BEGIN
 ASM
   LES DI,[BP+6]
   MOV AL,ES:[DI+VISIBLE]
   OR AL,AL
   JNZ @GOON
   LEAVE
   RETF
  @GOON:
   MOV R,FALSE
   PUSH ES:[DI+X]
   PUSH ES:[DI+Y]
   PUSH ES:[DI+H]
   PUSH ES:[DI+B]
   CALL WINDOW
   LES DI,[BP+6]
   DB 026h,066h,08Bh,045h,UNDERL
   DB 66h;OR AX,AX
   JZ @ENDLOOP
  @NEXTLOOP:
   DB 66h;MOV WORD PTR P,AX
   MOV BL,R
   OR BL,I
   PUSH BX
   DB 66h;PUSH AX
   CALL TWIN.MOUSEH
   OR R,AL
   LES DI,P
   DB 026h,066h,08Bh,045h,LAST
   DB 066h;OR AX,AX
   JNZ @NEXTLOOP
  @ENDLOOP:
   LES DI,[BP+6]
   MOV AL,R
   MOV ES:[DI+CUNDER],AL
   OR AL,I
   MOV ES:[DI+COTHER],AL
   CALL GETADDX
   MOV BX,AX
   MOV CX,SMSX
   MOV DX,SMSY
   CMP CX,BX
   JB @NONVIS
   CALL GETADDY
   CMP DX,AX
   JB @NONVIS
   CALL GETMAXX
   ADD AX,BX
   CMP CX,AX
   JA @NONVIS
   CALL GETMAXY
   MOV BX,AX
   CALL GETADDY
   ADD AX,BX
   CMP DX,AX
   JA @NONVIS
   CALL GETVIS
   MOV ES:[DI+CIN],AL
   JMP @EXTVIS
  @NONVIS:
   MOV ES:[DI+CIN],FALSE
  @EXTVIS:
   CALL GETSUBX
   ADD CX,AX
   CALL GETADDX
   SUB CX,AX
   MOV ES:[DI+CDX],CX
   CALL GETSUBY
   ADD DX,AX
   CALL GETADDY
   SUB DX,AX
   MOV ES:[DI+CDY],DX
   MOV AX,SMSB
   MOV ES:[DI+CDB],AX
 END;
 R:=MOUSE OR R;
 ASM
   CALL BWIN
 END;
 MOUSEH:=R;
END;
PROCEDURE TWIN.KEY(K:LONGINT);ASSEMBLER;
ASM
END;
PROCEDURE TWIN.KEYH(K:LONGINT);
VAR P:PWIN;
BEGIN
 ASM
   LES DI,[BP+6]
   MOV AL,ES:[DI+VISIBLE]
   OR AL,AL
   JNZ @GOON
   LEAVE
   RETF
  @GOON:
 END;
 KEY(K);
 ASM
   LES DI,[BP+6]
   DB 026h,066h,08Bh,045h,UNDER
   DB 066h;OR AX,AX
   JZ @ENDLOOP
  @NEXTLOOP:
   DB 66h;MOV WORD PTR P,AX
   DB 66h;PUSH WORD PTR K
   DB 66h;PUSH AX
   CALL TWIN.KEYH
   LES DI,P
   DB 026h,066h,08Bh,045h,NEXT
   DB 066h;OR AX,AX
   JNZ @NEXTLOOP
  @ENDLOOP:
 END;
END;
PROCEDURE TWIN.PAINTH;
VAR P:PWIN;
BEGIN
 ASM
   LES DI,[BP+6]
   MOV AL,ES:[DI+VISIBLE]
   OR AL,AL
   JNZ @GOON
   LEAVE
   RET
  @GOON:
   PUSH ES:[DI+X]
   PUSH ES:[DI+Y]
   PUSH ES:[DI+H]
   PUSH ES:[DI+B]
   CALL WINDOW
 END;
 PAINT;
 ASM
   LES DI,[BP+6]
   DB 026h,066h,08Bh,045h,UNDER
   DB 066h;OR AX,AX
   JZ @ENDLOOP
  @NEXTLOOP:
   DB 66h;MOV WORD PTR P,AX
   DB 66h;PUSH AX
   CALL TWIN.PAINTH
   LES DI,P
   DB 026h,066h,08Bh,045h,NEXT
   DB 66h;OR AX,AX
   JNZ @NEXTLOOP
  @ENDLOOP:
   CALL BWIN
 END;
END;
FUNCTION TWIN.MOUSE:BOOLEAN;ASSEMBLER;
ASM
  XOR AX,AX
END;
PROCEDURE TWIN.PAINT;ASSEMBLER;
ASM
END;
PROCEDURE TWIN.SETOVER(P:PWIN);
BEGIN
 INC(INET);
 IF OVER<>NIL THEN OVER^.DONEU(@SELF);
 IF BACK=@SELF THEN
 BEGIN
  BACK:=NIL;
 END;
 IF LAST=NIL THEN OVER^.UNDER:=NEXT ELSE LAST^.NEXT:=NEXT;
 IF NEXT=NIL THEN OVER^.UNDERL:=LAST ELSE NEXT^.LAST:=LAST;
 ASM
   LES DI,[BP+6]
   DB 066h;MOV AX,WORD PTR P
   DB 026h,066h,089h,045h,OVER
   DB 66h;OR AX,AX
   JNZ @MAINSETUP
   DB 026h,066h,089h,045h,NEXT
   JMP @MAINGOON
  @MAINSETUP:
   CLI
   PUSH DS
   LDS SI,P
   DB 03Eh,066h,08Bh,044h,UNDER
   DB 026h,066h,089h,045h,NEXT
   MOV WORD PTR DS:[SI+UNDER],DI
   MOV WORD PTR DS:[SI+UNDER+2],ES
   DB 66h;OR AX,AX
   JNZ @SETUPNEXT
   MOV WORD PTR DS:[SI+UNDERL],DI
   MOV WORD PTR DS:[SI+UNDERL+2],ES
   JMP @GOONSETUP
  @SETUPNEXT:
   LDS SI,ES:[DI+NEXT]
   MOV WORD PTR DS:[SI+LAST],DI
   MOV WORD PTR DS:[SI+LAST+2],ES
  @GOONSETUP:
   POP DS
   STI
  @MAINGOON:
   LES DI,[BP+6]
   DB 66h;XOR AX,AX
   DB 026h,066h,089h,045h,LAST
   DB 026h,066h,089h,045h,UNDERL
   DB 026h,066h,089h,045h,UNDER
   DB 66h;MOV AX,WORD PTR P
   DB 66h;OR AX,AX
   JZ @NOINITU
   DB 66h;PUSH WORD PTR [BP+6]
   DB 66h;PUSH AX
   CALL TWIN.INITU
  @NOINITU:
   DEC INET
 END;
END;
DESTRUCTOR TWIN.DONE;
BEGIN
 INC(INET);
 IF FOC THEN UNFOCUS;
 IF OVER<>NIL THEN OVER^.DONEU(@SELF);
 IF BACK=@SELF THEN
 BEGIN
  BACK:=NIL;
 END;
 WHILE UNDER<>NIL DO DISPOSE(UNDER,DONE);
 IF LAST=NIL THEN OVER^.UNDER:=NEXT ELSE LAST^.NEXT:=NEXT;
 IF NEXT=NIL THEN OVER^.UNDERL:=LAST ELSE NEXT^.LAST:=LAST;
 DEC(INET);
END;
CONSTRUCTOR TWIN.INIT(BAS:PWIN;PX,PY:INTEGER;PH,PB:WORD;INPF,WINF:BOOLEAN);ASSEMBLER;
ASM
  INC INET
  LES DI,[BP+6]
  MOV ES:[DI+VISIBLE],TRUE
  MOV ES:[DI+SEL],FALSE
  MOV ES:[DI+FOC],FALSE
  DB 066h;MOV AX,WORD PTR BAS
  DB 026h,066h,089h,045h,OVER
  DB 66h;OR AX,AX
  JNZ @MAINSETUP
  DB 026h,066h,089h,045h,NEXT
  JMP @MAINGOON
 @MAINSETUP:
  CLI
  PUSH DS
  LDS SI,BAS
  DB 03Eh,066h,08Bh,044h,UNDER
  DB 026h,066h,089h,045h,NEXT
  MOV WORD PTR DS:[SI+UNDER],DI
  MOV WORD PTR DS:[SI+UNDER+2],ES
  DB 66h;OR AX,AX
  JNZ @SETUPNEXT
  MOV WORD PTR DS:[SI+UNDERL],DI
  MOV WORD PTR DS:[SI+UNDERL+2],ES
  JMP @GOONSETUP
 @SETUPNEXT:
  LDS SI,ES:[DI+NEXT]
  MOV WORD PTR DS:[SI+LAST],DI
  MOV WORD PTR DS:[SI+LAST+2],ES
 @GOONSETUP:
  POP DS
  STI
 @MAINGOON:
  LES DI,[BP+6]
  DB 66h;XOR AX,AX
  DB 026h,066h,089h,045h,LAST
  DB 026h,066h,089h,045h,UNDERL
  DB 026h,066h,089h,045h,UNDER
  MOV AX,PX
  MOV ES:[DI+X],AX
  MOV AX,PY
  MOV ES:[DI+Y],AX
  MOV AX,PH
  MOV ES:[DI+H],AX
  MOV AX,PB
  MOV ES:[DI+B],AX
  DB 66h;MOV AX,WORD PTR BAS
  DB 66h;OR AX,AX
  JZ @NOINITU
  DB 66h;PUSH WORD PTR [BP+6]
  DB 66h;PUSH AX
  CALL TWIN.INITU
 @NOINITU:
  DEC INET
END;
END.